#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100003
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
int t;
int n;
int depth[MAXN];
int mins;
vector <int> adj[MAXN];
void dfs(int ver, int par)
{
    int cnt_outgoing = 0;
    for (auto i: adj[ver])
        if (i != par)
    {
        cnt_outgoing++;
        depth[i] = depth[ver] + 1;
        dfs(i, ver);
    }
    if (cnt_outgoing == 0)
        mins = min(mins, depth[ver]);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> t;
    for (int i = 1; i <= t; i++)
    {
        cin >> n;
        for (int i = 0; i < n; i++)
            adj[i].clear();
        for (int i = 1; i < n; i++)
        {
            int a, b;
            cin >> a >> b;
            adj[a].push_back(b);
            adj[b].push_back(a);
        }
        mins = 100000000;
        depth[0] = 1;
        dfs(0, -1);
        cout << mins << endl;
    }
}
