#include "namuhs.h"

void find_max(int n, int &left, int &right) {
	int low = 0, high = 0;
	for (int i = 2; i <= n; i++) {
		if (compare_segments(i, i, low, high)) low = high = i;
	}
	while (low > 1 && high < n) {
		if (compare_segments(low - 1, high, low, high + 1)) low--;
		else high++;
	}
    while (low > 1 && compare_segments(low - 1, high, low, high)) low--;
    while (high < n && compare_segments(low, high + 1, low, high)) high++;
	left = low;
	right = high;
}

