#include "namuhs.h"

void find_max(int n, int &left, int &right) {
    int low = 1, high = n;
    int maxLeft, maxRight;
    while (low <= high) {
		int mid = (low + high) >> 1;
		bool found = false;
		for (int i = 1; i <= n - mid + 1; i++) {
			if (compare_segments(i, i + mid - 1, maxLeft, maxRight)) {
				maxLeft = i;
				maxRight = i + mid - 1;
				found = true;
			}
		}
		if (found) low = mid + 1;
		else high = mid - 1;
    }
    left = maxLeft;
    right = maxRight;
}

