#include <bits/stdc++.h>
using namespace std;
//#JP2GMD2137 - Jan Pawel II Guru Mojej Duszy :)
const int MAXN=1e5+10;
const int inf=1e9+2137;

int dp[MAXN];
bool odw[MAXN];
bool odw2[MAXN];
vector<int> vec[MAXN];
vector<int> sons[MAXN];
int sub[MAXN];

void dfs(int node)
{
    odw[node]=true;
    for(int i=0;i<vec[node].size();i++)
    {
        if(odw[vec[node].at(i)]==false)
        {
            odw[vec[node].at(i)]=true;
            sons[node].push_back(vec[node].at(i));
            dfs(vec[node].at(i));
        }
    }
    if(sons[node].size()==0)
    {
        dp[node]=1;
    }
    else
    if(sons[node].size()==1)
    {
        if(dp[sons[node].at(0)]==1)
            dp[node]=2;
        else
            dp[node]=dp[sons[node].at(0)];
    }
    else
    {
        int max1=-inf,max2=-inf;
        for(int i=0;i<sons[node].size();i++)
        {
            if(dp[sons[node].at(i)]>=max1)
            {
                max2=max1;
                max1=dp[sons[node].at(i)];
            }
            else
            if(dp[sons[node].at(i)]>=max2)
                max2=dp[sons[node].at(i)];
        }
        if(max1==max2)
            dp[node]=max1+1;
        else
            dp[node]=max1;
    }
}

void dfs2(int node)
{
    odw2[node]=true;
    for(int i=0;i<vec[node].size();i++)
    {
        if(odw2[vec[node].at(i)]==false)
        {
            odw2[vec[node].at(i)]=true;
            dfs2(vec[node].at(i));
            sub[node]+=sub[vec[node].at(i)];
        }
    }
    sub[node]=max(sub[node],1);
}

bool is_centroid(int node,int n)
{
    int sum=0,mx=0;
    for(int i=0;i<vec[node].size();i++)
    {
        sum+=sub[vec[node].at(i)];
        mx=max(mx,sub[vec[node].at(i)]);
    }
    if(mx<=n/2&&n-sum-1<=n/2)
        return true;
    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,t,i,j,l,a,b,ans;
    cin>>t;
    for(j=0;j<t;j++)
    {
        cin>>n;
        for(i=0;i<n-1;i++)
        {
            cin>>a>>b;
            vec[a].push_back(b);
            vec[b].push_back(a);
        }
        ans=inf;
        dfs2(0);
        for(i=0;i<n;i++)
        {
            if(is_centroid(i,n)==true)
            {
                dfs(i);
                ans=min(ans,dp[i]);
                for(l=0;l<n;l++)
                {
                    odw[l]=false;
                    dp[l]=0;
                    sons[l].clear();
                }
            }
        }
        for(i=0;i<n;i++)
        {
            odw2[i]=false;
            sub[i]=0;
            vec[i].clear();
        }
        cout<<ans<<"\n";
    }
}
