#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

const int N=1024+5;

int n,cntt;
bool tai[N][N];
int m;
int sum[N*N];
vector<int>id[N];
vector<int>aux[N];

bool seen[N];
bool now[N];
bool viz[N*N]; /// viz[road]

inline void fvec(int nod)
{
    seen[nod]=now[nod]=1;
    for(auto &i:id[nod])
    {
        int nou=sum[i]-nod;
        if(seen[nou]==0)
        {
            fvec(nou);
        }
    }
}

vector<vector<int>>print;

bool vec[N][N];

vector<int>road;

inline void go(int nod)
{
    while(!aux[nod].empty())
    {
        int i=aux[nod].back();
        aux[nod].pop_back();
        if(viz[i]==0)
        {
            viz[i]=1;
            go(sum[i]-nod);
        }
    }
    road.push_back(nod);
}

inline void tri(int nod)
{
    for(int i=1;i<=m;i++)
    {
        viz[i]=0;
    }
    for(int i=1;i<=n;i++)
    {
        aux[i]=id[i];
    }
    road.clear();
    go(nod);
}

inline bool is_ok()
{
    for(int i=0;i+1<road.size();i++)
    {
        if(vec[road[i]][road[i+1]]==0)
        {
            return 0;
        }
    }
    return 1;
}

inline void clr(int start)
{
    for(int i=1;i<=n;i++)
    {
        now[i]=0;
    }
    fvec(start);
    for(int i=1;i<=n;i++)
    {
        if(now[i])
        {
            tri(i);
            if(is_ok())
            {
                print.push_back({});
                for(auto &it:road)
                {
                    print.back().push_back(it-1);
                }
                print.back().push_back(-1);
                return;
            }
        }
    }
}

int main()
{
    cin>>n>>cntt;
    n++;
    for(int i=1;i<=cntt;i++)
    {
        int a,b;
        cin>>a>>b;
        a++;
        b++;
        if(a>b)
        {
            swap(a,b);
        }
        tai[a][b]=1;
    }
    for(int a=1;a<=n;a++)
    {
        for(int b=a;b<=n;b++)
        {
            if(tai[a][b])
            {
                continue;
            }
            m++;
            sum[m]=a+b;
            id[a].push_back(m);
            id[b].push_back(m);
            vec[a][b]=vec[b][a]=1;
        }
    }
    for(int i=1;i<=n;i++)
    {
        if(seen[i]==0)
        {
            clr(i);
        }
    }
    cout<<print.size()<<"\n";
    for(auto &i:print)
    {
        for(auto &j:i)
        {
            cout<<j<<" ";
        }
        cout<<"\n";
    }
    return 0;
}
/**
**/


