#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int N=1000+5;

int n;
vector<int>g[N];
int dist[N][N];
bool viz[N];

inline void dfs(int who,int nod)
{
    for(auto &nou:g[nod])
    {
        if(dist[who][nou]==-1)
        {
            dist[who][nou]=dist[who][nod]+1;
            dfs(who,nou);
        }
    }
}

int mx;

inline void go(int who,int nod)
{
    mx=max(mx,dist[who][nod]);
    viz[nod]=1;
    for(auto &nou:g[nod])
    {
        if(viz[nou]==0)
        {
            go(who,nou);
        }
    }
}

int kek[N],cnt;

int main()
{
    int t;
    cin>>t;
    for(int tc=1;tc<=t;tc++)
    {
        cin>>n;
        for(int i=1;i<=n;i++)
        {
            g[i].clear();
        }
        for(int i=1;i<n;i++)
        {
            int a,b;
            cin>>a>>b;
            a++;
            b++;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                dist[i][j]=-1;
            }
            dist[i][i]=0;
            dfs(i,i);
        }
        int ans=0;
        for(int nod=1;nod<=n;nod++)
        {
            if(g[nod].size()==1)
            {
                continue;
            }
            for(int i=1;i<=n;i++)
            {
                viz[i]=0;
            }
            viz[nod]=1;
            cnt=0;
            for(auto &nou:g[nod])
            {
                mx=-1;
                go(nod,nou);
                kek[++cnt]=mx;
            }
            sort(kek+1,kek+cnt+1);
            if(cnt>=3)
            {
                ans=max(ans,kek[cnt-2]);
            }
        }
        ans++;
        cout<<ans<<"\n";
    }
    return 0;
}
