#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

const int N=100000+5;

int n;
vector<int>g[N];
bool viz[N];
int dp[N];

inline void dfs(int nod)
{
    viz[nod]=1;
    if(g[nod].size()==1)
    {
        dp[nod]=1;
        return;
    }
    int mi=(1<<30),ma=-(1<<30);
    for(auto &nou:g[nod])
    {
        if(viz[nou]==0)
        {
            dfs(nou);
            dp[nod]=max(dp[nod],dp[nou]);
            mi=min(mi,dp[nou]);
            ma=max(ma,dp[nou]);
        }
    }
    if(mi==ma)
    {
        dp[nod]=ma+1;
    }
    else
    {
        dp[nod]=ma;
    }
}

inline int slove(int root)
{
    for(int i=1;i<=n;i++)
    {
        viz[i]=0;
        dp[i]=-1;
    }
    dfs(root);
    return dp[root];
}

int main()
{
  //  freopen("input","r",stdin);
  //  freopen("output","w",stdout);
    int t;
    cin>>t;
    for(int tc=1;tc<=t;tc++)
    {
        cin>>n;
        if(n==1)
        {
            cout<<"1\n";
            continue;
        }
        for(int i=1;i<=n;i++)
        {
            g[i].clear();
        }
        for(int i=1;i<n;i++)
        {
            int a,b;
            cin>>a>>b;
            a++;
            b++;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        int ans=slove(1);
        for(int i=2;i<=n;i++)
        {
            ans=max(ans,slove(i));
        }
        cout<<ans<<"\n";
    }
    return 0;
}
