#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

const int N = 1e5 + 7;

int ds[N], q[N];
bool viz[N];

vector < int > v[N];

void bfs(int nod) {
    memset(ds, 0, sizeof ds);
    memset(viz, 0, sizeof viz);
    int st = 0, dr = -1;
    q[++dr] = nod;
    viz[nod] = 1;
    while (st <= dr) {
        int x = q[st++];
        for (auto i : v[x]) {
            if (!viz[i]) {
                ds[i] = ds[x] + 1;
                q[++dr] = i;
                viz[i] = 1;
            }
        }
    }
}

int main()
{
    int t;
    cin >> t;
    while (t--) {
        int n, a, b;
        cin >> n;
        for (int i = 0; i < n; ++i)
            v[i].clear();
        for (int i = 1; i < n; ++i) {
            cin >> a >> b;
            v[a].push_back(b);
            v[b].push_back(a);
        }
        bfs(1);
        int d(0), p1(0), p2(0);
        for (int i = 1; i < n; ++i) {
            if (d < ds[i]) {
                d = ds[i];
                p1 = i;
            }
        }
        bfs(p1);
        d = 0;
        for (int i = 1; i < n; ++i) {
            if (d < ds[i]) {
                d = ds[i];
                p2 = i;
            }
        }
        cout << (d + 3) / 2 << '\n';
    }
    return 0;
}
