#include <fstream>
#include <set>

using namespace std;
ifstream cin ("file.in");
ofstream cout ("file.out");

const int N = 1048580;

int mins(N);

set < pair < int, int > > s;

int ans[N], v[N], k, x[N][2];
bool viz[N], l[N];
int dp[N][2];

void bkt(int p, int cst) {
    if (p > 1) {
        --p;
        dp[p][0] = min(dp[p - 1][0] + (x[v[p]][0] != x[v[p - 1]][1]), dp[p - 1][1] + (x[v[p]][0] != x[v[p - 1]][0]));
        dp[p][1] = min(dp[p - 1][0] + (x[v[p]][1] != x[v[p - 1]][1]), dp[p - 1][1] + (x[v[p]][1] != x[v[p - 1]][0]));
        cst = min(dp[p][0], dp[p][1]);
        ++p;
    }
    if (cst >= mins)
        return;
    if (p == k) {
        mins = cst;
        for (int i = 0; i < k; ++i)
            ans[i] = v[i];
        return;
    }
    for (int i = 0; i < k; ++i) {
        if (!viz[i]) {
            v[p++] = i;
            viz[i] = 1;
            bkt(p, cst);
            --p;
            viz[i] = 0;
        }
    }
}

int main()
{
    int n, m, a, b;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        s.insert({a, b});
    }
    for (int i = 0; i <= n; ++i)
        for (int j = i; j <= n; ++j)
            if (s.find({i, j}) == s.end())
                x[k][0] = i, x[k++][1] = j;
    bkt(0, 0);
    cout << mins << '\n';
    for (int p = 1; p < k; ++p) {
        dp[p][0] = min(dp[p - 1][0] + (x[ans[p]][0] != x[ans[p - 1]][1]), dp[p - 1][1] + (x[ans[p]][0] != x[ans[p - 1]][0]));
        dp[p][1] = min(dp[p - 1][0] + (x[ans[p]][1] != x[ans[p - 1]][1]), dp[p - 1][1] + (x[ans[p]][1] != x[ans[p - 1]][0]));
    }
    if (mins == dp[k - 1][0])
        l[k - 1] = 0;
    else
        l[k - 1] = 1;
    for (int p = k - 2; p >= 0; --p) {
        if (l[p + 1]) {
            if (dp[p][0] + (x[ans[p + 1]][1] != x[ans[p]][1]) == dp[p + 1][1])
                l[p] = 0;
            else
                l[p] = 1;
        }
        else {
            if (dp[p][0] + (x[ans[p + 1]][0] != x[ans[p]][1]) == dp[p + 1][0])
                l[p] = 0;
            else
                l[p] = 1;
        }
    }
    cout << x[ans[0]][l[0]] << ' ';
    for (int i = 0; i < k; ++i) {
        if (i && x[ans[i - 1]][1 - l[i - 1]] != x[ans[i]][l[i]])
            cout << "-1\n" << x[ans[i]][l[i]] << ' ';
        cout << x[ans[i]][1 - l[i]] << ' ';
    }
    cout << "-1\n";
    return 0;
}
