#include "namuhs.h"
#include <iostream>

using namespace std;

void my_fmax(int st, int dr, int& lm, int& rm, int& cs, int& cd) {
    if (st == dr) {
        lm = rm = st;
        cs = cd = st;
        return;
    }
    int st1, dr1, st2, dr2, cs1, cs2, cd1, cd2;
    int mij = ((dr + st)>>1);
    my_fmax(st, mij, st1, dr1, cs1, cd1);
    my_fmax(mij + 1, dr, st2, dr2, cs2, cd2);
    cs = cs1;
    cd = cd1;
    if (st1 + 1 <= dr2 - 1 && compare_segments(st1 + 1, dr2 - 1, cs, cd)) {
        cs = st1 + 1;
        cd = dr2 - 1;
    }
    if (compare_segments(cs2, cd2, cs, cd)) {
        cs = cs2;
        cd = cd2;
    }
    if (compare_segments(st, cs, cs, cs))
        cs = st;
    if (compare_segments(cd, dr, cd, cd))
        cd = dr;
    if (compare_segments(st1, st1, st1, st2))
        lm = st2;
    else
        lm = st1;
    if (compare_segments(dr1, dr2, dr2, dr2))
        rm = dr2;
    else
        rm = dr1;
    return;
}

void find_max(int N, int& left, int& right) {
    int st1, dr1, st2, dr2, cs1, cs2, cd1, cd2;
    int mij = ((N + 1)>>1);
    my_fmax(1, mij, st1, dr1, cs1, cd1);
    my_fmax(mij + 1, N, st2, dr2, cs2, cd2);
    left = cs1;
    right = cd1;
    if (st1 + 1 <= dr2 - 1 && compare_segments(st1 + 1, dr2 - 1, left, right)) {
        left = st1 + 1;
        right = dr2 - 1;
    }
    if (compare_segments(cs2, cd2, left, right)) {
        left = cs2;
        right = cd2;
    }
    if (compare_segments(right, N, right, right))
        right = N;
    if (compare_segments(1, left, left, left))
        left = 1;
}

