#include <iostream>
#include <vector>

using namespace std;

#define ll long long
#define MIN(a , b) (((a) < (b)) ? (a) : (b))
#define MAX(a , b) (((a) < (b)) ? (b) : (a))

int const nmax = 1000;
vector<int> g[5 + nmax];
int dp[5 + nmax];

/*
vector<int> g2[5 + nmax];

void addedge(int x , int y){
  g2[x].push_back(y);
  g2[y].push_back(x);
}

void dfs(int node , int parent ,int newparent){

  if(g[node].size() == 1) {
    addedge(node , newparent);
  } else if(2 < g[node].size()){
    addedge(node , newparent);
    for(int h = 0 ; h < g[node].size() ; h++){
      int to = g[node][h];
      if(to != parent)
        dfs(to , node , node);
    }
  } else {
    for(int h = 0 ; h < g[node].size() ; h++){
      int to = g[node][h];
      if(to != parent)
        dfs(to , node , newparent);
    }
  }
}

void dfsmin(int node , int parent ,int level , int &steps , int &target){
  steps = level;
  target = node;

  for(int h = 0 ; h < g[node].size() ; h++){
    int to = g[node][h];
    if(to != parent){
      int steps2  , target2;
      dfsmin(to , node ,level + 1 steps2 , target2);
      if(steps < steps2) {
        steps = steps2;
        target = target2;
      }
    }
  }
}
*/

void dfs(int node , int parent){
  if(g[node].size() == 1)
    dp[node] = 1;

  dp[node] = 1;

  for(int h = 0 ; h < g[node].size() ; h++){
    int to = g[node][h];
    if(to != parent) {
      dfs(to , node);
      dp[node] = MAX(dp[node] , dp[to] + 1);
    }
  }

}
void solve(){
  int n;
  cin >> n;

  for(int i = 0 ; i <= n  ; i++){
    g[i].clear();
    dp[i] = 0;
  }

  for(int i = 1 ; i < n ; i++){
    int x , y;
    cin >> x >> y;
    g[x].push_back(y);
    g[y].push_back(x);
  }

  int smin = n;
  for(int i = 0 ; i < n ; i++){
    dfs(i , -1);
    smin = MIN(smin , dp[i]);
    //cout << ":" << i << " " << dp[i] << ":" << '\n';
  }
  cout << smin  << '\n';


}


int main()
{
  int t;
  cin >> t;
  for(int testcase = 1 ; testcase <= t ; testcase++){
    solve();
  }

  return 0;
}
