#include <bits/stdc++.h>

using namespace std;

const int N = 1048576;

int m, n, x, y, cc;
int V, chains;

vector <int> v[N + 5], sol[N + 5];
vector <int> g[1030];
bitset <N + 5> f, viz, ing, OK;
int cnt[1030];

void dfs(int nod, vector <int> &v, bool ok) {
  viz[nod] = 1;
  v.push_back(nod);
  if(ok)
    return;
  for(auto i : g[nod]) {
    if(i == nod)
      dfs(i, v, 1);
    if(!viz[i])
      dfs(i, v, 0);
  }
}

void dfs2(int nod, vector <int> &v) {
  v.push_back(nod);
  if(OK[nod]) {
    v.push_back(nod);
    OK[nod] = 0;
  }
  for(auto i : g[nod]) {
    int cod;
    if(i > nod)
      cod = nod * (m + 1) + i;
    else
      cod = i * (m + 1) + nod;
    if(!f[cod]) {
      f[cod] = 1;
      cnt[i]++; cnt[nod]++;
      dfs2(i, v);
      break;
    }
  }
}

int main() {
  cin >> m >> n;
  for(int i = 1; i <= n; i++) {
    cin >> x >> y;
    f[x * (m + 1) + y] = 1;
  }
  for(int i = 0; i <= m; i++) {
    for(int j = i + 1; j <= m; j++) {
      if(!f[i * (m + 1) + j]) {
        g[i].push_back(j);
        g[j].push_back(i);
        ing[i] = ing[j] = 1;
      }
    }
  }
  for(int i = 0; i <= m; i++) {
    if(!f[i * (m + 1) + i])
      OK[i] = 1;
  }
  for(int i = 0; i <= m; i++) {
    if(!viz[i] && ing[i]) {
      dfs(i, v[cc], 0);
      cc++;
    }
  }
  for(int i = 0; i < cc; i++) {
    int cnt0 = 0, cnt1 = 0, ct = 0;
    for(auto j : v[i]) {
      cnt0 += (g[j].size() % 2 == 0);
      cnt1 += (g[j].size() % 2 == 1);
    }
    if(cnt1 && cnt1 != v[i].size()) {
      for(auto j : v[i]) {
        if(g[j].size() % 2 && !OK[j]) {
          dfs2(j, sol[chains]);
          chains++;
          break;
        }
      }
    } else if(cnt0 && cnt0 == v[i].size()) {
      dfs2(v[i][0], sol[chains]);
      chains++;
    } else {
      while(true) {
        int mn = 1e9, p;
        for(int j = 0; j < v[i].size(); j++) {
          if(g[v[i][j]].size() - cnt[v[i][j]] < mn && g[v[i][j]].size() - cnt[v[i][j]]) {
            mn = g[v[i][j]].size() - cnt[v[i][j]];
            p = j;
          }
        }
        if(mn == 1e9)
          break;
        dfs2(p, sol[chains]);
        chains++;
      }
    }
  }
  cout << chains << "\n";
  for(int i = 0; i < chains; i++) {
    for(auto j : sol[i])
      cout << j << " ";
    cout << "-1\n";
  }
  return 0;
}
