#include <bits/stdc++.h>

using namespace std;

const int NMAX=1e5+5;

vector <int> G[NMAX];

int Teste, t, N, i, X, Y, ap[NMAX];

int Level[NMAX], T[NMAX];

bool Sel[NMAX];

void BFS (int Node)
{
    queue <int> Q;

    Q.push(Node);

    while(!Q.empty())
    {
        int j=Q.front();

        Sel[j]=true;

        for(int i=0; i<G[j].size(); ++i)
            if(!Sel[G[j][i]])
            {
                Q.push(G[j][i]);

                Level[G[j][i]]=Level[j]+1;

                T[G[j][i]]=j;

                ap[j]=true;
            }

        Q.pop();
    }
}

int main()
{
    cin.tie(NULL);

    cin>>Teste;

    for(t=1; t<=Teste; ++t)
    {
        cin>>N;

        for(i=0; i<N; ++i)
        {
            if(!G[i].empty())
                G[i].clear();

            Sel[i]=false;

            Level[i]=0;

            T[i]=0;

            ap[i]=0;
        }

        for(i=0; i<N-1; ++i)
        {
            cin>>X>>Y;

            G[X].push_back(Y);
            G[Y].push_back(X);
        }

        Level[0]=1;

        BFS(0);

        int ans=INT_MAX;

        for(int i=1; i<N; ++i)
        {
            //Verific daca nodul "i" este terminal, adica nu exista nod cu tatal T;

            bool ok=true;

            if(ap[i])
                ok=false;

            if(ok==true)
                ans=min(ans, Level[i]);

        }

        cout<<ans<<'\n';

    }

    return 0;
}
