#include <bits/stdc++.h>

using namespace std;

const int NMAX=1e5+5;

vector <int> G[NMAX];

int T, t, N, i, X, Y;

bool Marked[NMAX];

int L[NMAX], R[NMAX];

bool cupleaza (int node)
{
    Marked[node]=true;

    for(int i=0; i<G[node].size(); ++i)
        if(R[G[node][i]]==0)
        {
            R[G[node][i]]=node;

            L[node]=G[node][i];

            return true;
        }

    for(int i=0; i<G[node].size(); ++i)
        if(R[G[node][i]] && !Marked[R[G[node][i]]] && cupleaza(R[G[node][i]]))
        {
            R[G[node][i]]=node;

            L[node]=G[node][i];

            return true;
        }

    return false;
}

int main()
{
    cin.tie(NULL);

    cin>>T;

    for(t=1; t<=T; ++t)
    {
        cin>>N;

        for(i=0; i<N; ++i)
        {
            if(!G[i].empty())
                G[i].clear();

            L[i]=R[i]=0;
        }

        for(i=0; i<N-1; ++i)
        {
            cin>>X>>Y;

            G[X].push_back(Y);
            //G[Y].push_back(X);
        }

        bool done=true;

        while(done==true)
        {
            done=false;

            for(i=0; i<N; ++i)
                Marked[i]=false;

            for(i=0; i<N; ++i)
                if(!Marked[i] && !L[i])
                    done|=cupleaza(i);
        }

        int cnt=0;

        for(i=0; i<N; ++i)
            if(L[i])
                cnt++;

        //Minimum vertex cover (MVC):
        cout<<--cnt<<'\n';
    }

    return 0;
}
