#include<iostream>
#include<stdio.h>
#include "namuhs.h"
using namespace std;

/*
int a_gr[1000001],n_gr;
bool compare_segments (int left1, int right1, int left2, int right2) {
    if ((left1>right1)||(left2>right2)||(left1<1)||(right1>n_gr)||(left2<1)||(right2>n_gr)) return true;
    long long int sum1=0,sum2=0,i;
    for (i=left1-1; i<right1; i++) {
        sum1+=a_gr[i];
        }
    for (i=left2-1; i<right2; i++) {
        sum2+=a_gr[i];
        }
    return (sum1>=sum2);
}
*/

const int MAXN = 1e5 + 7;

struct Node {
    pair <int, int> pref, post, ans;
};

Node tree[MAXN << 2];

void merge(int v, int tl, int tr) {
    //pref
    tree[v].pref = tree[v * 2 + 1].pref;
    int tmp = tree[v * 2 + 2].pref.second;
    if (compare_segments(tl, tmp, tree[v].pref.first, tree[v].pref.second)) tree[v].pref = {tl, tmp};

    //post
    tree[v].post = tree[v * 2 + 2].post;
    tmp = tree[v * 2 + 1].post.first;
    if (compare_segments(tmp, tr, tree[v].post.first, tree[v].post.second)) tree[v].post = {tmp, tr};

    //ans
    tree[v].ans = tree[v * 2 + 1].ans;
    if (compare_segments(tree[v * 2 + 2].ans.first, tree[v * 2 + 2].ans.second, tree[v].ans.first, tree[v].ans.second)) tree[v].ans = tree[v * 2 + 2].ans;
    int l = tree[v * 2 + 1].post.first;
    int r = tree[v * 2 + 2].pref.second;
    if (compare_segments(l, r, tree[v].ans.first, tree[v].ans.second)) tree[v].ans = {l, r};
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        tree[v].pref = {tl, tl};
        tree[v].post = {tl, tl};
        tree[v].ans = {tl, tl};
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v * 2 + 1, tl, tm); build(v * 2 + 2, tm + 1, tr);
    merge(v, tl, tr);
}

void find_max(int n, int &l, int &r) {
    build(0, 1, n);
    l = tree[0].ans.first; r = tree[0].ans.second;
}

/*
int main () {
    long long int i;
    int left,right;
    scanf("%d",&n_gr);
    for (i=0; i<n_gr; i++) {
        scanf("%d",&a_gr[i]);
        }
    find_max(n_gr,left,right);
    printf("%d %d",left,right);
    cout << endl ;
    return 0;
}
*/
