#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;

int dp[MAXN];
vector <int> g[MAXN];

const int INF = 1e9 + 7;

int dp1[MAXN], dp2[MAXN];

void calc(int u, int parent) {
    dp1[u] = 1;
    for (int v : g[u]) {
        if (v == parent) continue;
        dp1[u] = max(dp1[u], dp1[v] + 1);
    }

    vector <int> a;
    for (int v : g[u]) {
        if (v == parent) continue;
        a.push_back(dp1[v]);
    }

    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());

    dp2[u] = INF;
    for (int v : g[u]) {
        if (v == parent) continue;

        int add = a.back();
        if (dp1[v] == a[0]) {
            if (a.size() == 1) add = -1;
            else add = a[1];
        }

        dp2[u] = min(dp2[u], max(dp2[v], add + 1));
    }

    if (dp2[u] == INF) dp2[u] = 1;

    if (a.size()) {
        dp1[u] = max(dp1[u], 2);
        dp2[u] = max(dp2[u], 2);
    }
}

void dfs(int u, int parent) {
    //cout << "in " << u << '\n';
    for (int v : g[u]) {
        if (v == parent) continue;
        dfs(v, u);
    }
    calc(u, parent);
    //cout << "out " << u << ' ' << dp1[u] << ' ' << dp2[u] << '\n';
}

void solve() {
    for (int i = 0; i < MAXN; ++i) g[i].clear();
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, 0);
    cout << dp2[0] << '\n';
}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }

    return 0;
}
