#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;
const int KIKOS = 207;

int n;
vector <int> g[MAXN];

mt19937 rnd(228);

double gettime() {
    return (double) clock() / CLOCKS_PER_SEC;
}

bool curr[MAXN], ncurr[MAXN], was[MAXN];
bool check(int k) {
    for (int i = 0; i < n; ++i) {
        curr[i] = 1;
    }

    vector <int> v;
    for (int i = 0; i < n; ++i) v.push_back(i);

    for (int it = 0; it < KIKOS; ++it) {

        if (gettime() > 1.7) {
            return 1;
        }

        for (int i = 0; i < n; ++i) was[i] = curr[i];

        shuffle(v.begin(), v.end(), rnd);
        for (int t = 0; t < k; ++t) curr[v[t]] = 0;
        bool ch = 0;
        for (int t = 0; t < n; ++t) ch |= curr[t];

        if (!ch) return 1;

        memset(ncurr, 0, sizeof ncurr);
        for (int i = 0; i < n; ++i) {
            if (curr[i]) {
                ncurr[i] = 1;
                for (int v : g[i]) ncurr[v] = 1;
            }
        }

        int cnt1 = 0;
        int cnt2 = 0;
        for (int i = 0; i < n; ++i) cnt1 += !was[i];
        for (int i = 0; i < n; ++i) cnt2 += !ncurr[i];

        if (cnt1 < cnt2) {
            for (int i = 0; i < n; ++i) curr[i] = ncurr[i];
        }
        else {
            for (int i = 0; i < n; ++i) curr[i] = was[i];
        }
    }

    return 0;
}

void solve() {
    for (int i = 0; i < MAXN; ++i) g[i].clear();
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int ans = 1; ; ++ans) {
        if (check(ans)) {
            cout << ans << '\n';
            return;
        }
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();

    return 0;
}
