#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T &a, T b) {
	if (b > a) {
		a = b;
	}
}

const int maxn = 10001;

int n;

vector<int> g[maxn];

int dp[maxn];

void dfs(int v, int par = -1) {
	int mx = 0;
	for (int to : g[v]) {
		if (to != par) {
			dfs(to, v);
			uax(mx, dp[to]);
		}
	}
	dp[v] = 1 + mx;
	for (int to : g[v]) {
		if (to != par) {
			uin(dp[v], max(mx, dp[to] + 1));
		}
	}
}

void solve() {
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		++u;
		++v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	int res = 0;
	for (int i = 1; i <= n; ++i) {
		dfs(i);
		if (i == 1) res = dp[1];
		else uin(res, dp[i]);	
	}
	cout << res << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int T;
	cin >> T;
	for (int iter = 0; iter < T; ++iter) {
		solve();
	}
	return 0;
}