#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define pb push_back
#define all(x) (x).begin(), x.end()
#define size(s) (int)(s).size()

void bye() {
    cout << "\n";
    exit(0);
}

int sum(int r){
    return r * (r + 1) / 2;
}

bool used[1025][1025];

int m, n;

int k = 0;
vector<vector<int>> ans;

void dfs(int x, int y){
    ans[k - 1].pb(x);
    used[x][y] = used[y][x] = 1;
    for(int xx = 0; xx <= m; xx++){
        if (!used[xx][y]){
            dfs(xx, y);
            return;
        }
    }
    for(int yy = 0; yy <= m; yy++){
        if (!used[x][yy]){
            dfs(x, yy);
            return;
        }
    }
    ans[k - 1].pb(y);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    freopen("input.txt", "r", stdin);
    cin >> m >> n;
    map<pair<int, int>, bool> erased;
    for(int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        used[x][y] = used[y][x] = 1;
    }
    for(int i = 0; i <= m; i++){
        for(int j = 0; j <= m; j++) {
            if (!used[i][j]){
                ++k;
                ans.pb({});
                dfs(i, j);
            }
        }
    }

    cout << k << '\n';
    for(int i = 0; i < k; i++){
        reverse(all(ans[i]));
        for(int v : ans[i])cout << v << ' ';
        cout << -1 << '\n';
    }
}
