#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define pb push_back
#define all(x) (x).begin(), x.end()
#define size(s) (int)(s).size()

void bye() {
    cout << "\n";
    exit(0);
}

int sum(int r){
    return r * (r + 1) / 2;
}

vector<vector<int>> g;
int n;
vector<int> d, par;

bool dfs(int v, int p, int k){
    d[v] = k;
    par[v] = p;
    for(int to : g[v]) {
        if (to == p) continue;
        dfs(to, v, k + 1);
    }
}

vector<int> len;
vector<int> mx_d;

int calc_dp(int v, int p) {
    int ans = 2, cnt = 0;
    bool out = 0;
    for(int to : g[v]) {
        if (to == p) continue;
        out = 1;
        int kek = calc_dp(to, v);
        if (kek == ans) ++cnt;
        if (kek > ans) {
            cnt = 1;
            ans = kek;
        }
    }
    if (!out) return 1;
    if (cnt > 2) ++ans;
   //cout << v << ' ' << ans << endl;
    return ans;
}

void solve() {
    cin >> n;
    if (n == 1) {
        cout << 1;
        return;
    }
    par.clear();
    g.clear();
    d.clear();
    mx_d.clear();
    len.clear();
    mx_d.resize(n);
    g.resize(n);
    len.resize(n);
    d.resize(n);
    par.resize(n);
    for(int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
    }
   // cout << "wow" << endl;
    dfs(0, -1, 1);
    int mx = 0;
    for(int i = 0; i < n; i++){
        if (d[i] > d[mx]){
            mx = i;
        }
    }
   // cout << "wow" << endl;
    if (d[mx] == n) {
        cout << 2;
        return;
    }
    dfs(mx, -1, 1);
    int mx2 = 0;
    for(int i = 0; i < n; i++) {
        if (d[i] > d[mx2]){
            mx2 = i;
        }
    }
    int need = d[mx2]/2;
    int y = mx2;
  //  cout << mx << ' ' << mx2 << ' ' << need << endl;
    while(need--){
      // cout << y << endl;
        y = par[y];
    }
   // cout << y << endl;
    dfs(y, -1, 1);
    int ans = 0;
    for(int i = 0; i < n; i++){
        if (d[i] > d[ans])
            ans = i;
    }
    cout << calc_dp(ans, -1);
}

int main() {
   // ios::sync_with_stdio(false);
   // cin.tie(NULL);
    freopen("input.txt", "r", stdin);
    int tt;
    cin >> tt;
    while(tt--){
        solve();
        cout << "\n";
    }
}
