#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define long ll
#define double ld

const int N = 1E5 + 10;

vector<int> g[N];

int dfs(int v, int p)
{
    int answer = 1;
    for (int u : g[v])
    {
        if (u != p)
        {
            answer = max(answer, dfs(u, v) + 1);
        }
    }
    return answer;
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        g[i].clear();
    }
    for (int a, b, i = 0; i < n - 1; ++i)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int answer = 1E9;
    for (int i = 0; i < n; ++i)
    {
        answer = min(answer, dfs(i, -1));
    }
    return answer;
}

int main()
{
#ifdef LOCAL_PC
    freopen("input.txt", "r", stdin);
#endif // LOCAL_PC
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    {
        cout << solve() << '\n';
    }

    return 0;
}

