#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define long ll
#define double ld

const int N = 1E5 + 10;

vector<int> g[N];
vector<int> traverse;

bool bad[N];

vector<int> good_list;

void euler_traverse(int v, int p)
{
    traverse.push_back(v);
    for (int u : g[v])
    {
        if (u != p)
        {
            euler_traverse(u, v);
        }
    }
}

int add(int v)
{
    int bound_cnt = 0;
    for (int a : good_list)
    {
        int flag = 0;
        for (int b : g[a])
        {
            if (bad[b])
            {
                flag = 1;
            }
        }
        bound_cnt += flag;
    }
    good_list.push_back(v);
    bad[v] = 0;
    return bound_cnt + 1;
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        g[i].clear();
    }
    for (int a, b, i = 0; i < n - 1; ++i)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int root = 0;
    int answer = 0;
    traverse.clear();
    good_list.clear();
    euler_traverse(root, -1);
    fill(bad, bad + N, 1);
    for (int v : traverse)
    {
        int cost = add(v);
        answer = max(answer, cost);
    }
    return answer;
}

int main()
{/*
#ifdef LOCAL_PC
    freopen("input.txt", "r", stdin);
#endif // LOCAL_PC*/
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    {
        cout << solve() << '\n';
    }

    return 0;
}

