#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define long ll
#define double ld

const int N = 1E5 + 10;

vector<int> g[N];

int solve(int v, int p)
{
    int answer = 1;
    vector<int> son;
    for (int u : g[v])
    {
        if (u != p)
        {
            answer = max(answer, 2);
            son.push_back(solve(u, v));
        }
    }
    sort(son.rbegin(), son.rend());
    if (son.size() > 0)
    {
        answer = max(answer, son[0]);
    }
    if (son.size() > 1)
    {
        answer = max(answer, son[1] + 1);
    }
    return answer;
}

int solve()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        g[i].clear();
    }
    for (int a, b, i = 0; i < n - 1; ++i)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    int min_answer = 1E9;
    for (int root = 0; root < n; ++root)
    {
        min_answer = min(min_answer, solve(root, -1));
    }
    return min_answer;
}

int main()
{
#ifdef LOCAL_PC
    freopen("input.txt", "r", stdin);
#endif // LOCAL_PC
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    {
        cout << solve() << '\n';
    }

    return 0;
}

