#include <bits/stdc++.h>

#define fi(n) for(int i = 0; i < n; ++i)
#define fie(n) for(int i = 0; i <= n; ++i)
#define fir(l, r) for(int i = l; i <= r; ++i)
#define fj(n) for(int j = 0; j < n; ++j)
#define fje(n) for(int j = 0; j <= n; ++j)
#define fjr(l, r) for(int j = l; j <= r; ++j)
#define fv(i, n) for(int i = 0; i < n; ++i)
#define fve(i, n) for(int i = 0; i <= n; ++i)
#define fvr(i, l, r) for(int i = l; i <= r; ++i)
#define pb push_back
#define mp make_pair
#define rn(n) int n; cin >> n;
#define sqr(x) ((x) * (x))
#define endl '\n'
//#define int ll

//#pragma comment (linker : "STACK:16777216")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = 1e5 + 10;
const int INF = 1e5 + 10;
const int MOD = 1e9 + 7;

vi d(N);
vvi a(N);

void dfs(int root, int pred = -1){
    fi(a[root].size()){
        if (a[root][i] != pred){
            dfs(a[root][i], root);
            d[root] = max(d[root], d[a[root][i]] + 1);
        }
    }
    return;
}

bool dfs1(int root, int pred, int x, int deep){
    int cnt = 0;
    bool res;
    vi next;
    fi(a[root].size()){
        if (a[root][i] != pred){
            if (d[a[root][i]] + 1 > x){
                ++cnt;
                if (deep > x && cnt > 1)
                    return 0;
                if (deep <= x && cnt > 2)
                    return 0;
                next.pb(a[root][i]);
            }
        }
    }
    if (!cnt)
        return 1;
    if (cnt == 1){
        int maxx = deep;
        fi(a[root].size()){
            if(a[root][i] != pred && a[root][i] != next[0])
                maxx = max(maxx, d[a[root][i]] + 1);
        }
        return dfs1(next[0], root, x, maxx + 1);
    }
    else {
        int max1 = deep, max2 = deep;
        fi(a[root].size()){
            if(a[root][i] != pred && a[root][i] != next[0])
                max1 = max(max1, d[a[root][i]] + 1);
            if(a[root][i] != pred && a[root][i] != next[1])
                max2 = max(max2, d[a[root][i]] + 1);
        }
        return dfs1(next[0], root, x, max1 + 1) && dfs1(next[1], root, x, max2 + 1);
    }
}

signed main(){
#ifdef LOCALFILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCALFILE

    rn(t);
    fv(x, t){
        rn(n);
        fi(n){
            a[i].clear();
            d[i] = 0;
        }
        fi(n - 1){
            rn(u); rn(v);
            a[u].pb(v);
            a[v].pb(u);
        }
        dfs(0);
        int l = 0, r = INF;
        while(r - l > 1){
            int m = (l + r) / 2;
            if (dfs1(0, -1, m, 0))
                r = m;
            else
                l = m;
        }
        cout << r + 1 << endl;
    }

    return 0;
}
