#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define pb emplace_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define INF 1e9
#define EPS 1e-4
#define MAXN int(1e6)
#define maxmin(x, y) mp(max(x, y), min(x, y))
#define elif else if

inline void Routine() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

template<class U, class T>
istream &operator >> (istream &in, pair<U, T> &p) {
    in >> p.fi >> p.se;
    return in;
}


template<class U, class T>
ostream &operator << (ostream &out, const pair<U, T> &p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template<class T>
istream &operator >> (istream &in, vector<T> &v) {
    for (auto &i : v) {
        in >> i;
    }
    return in;
}

template<class T>
ostream &operator << (ostream &out, const vector<T> &v) {
    for (auto &i : v) {
        out << i << ' ';
    }
    return out;
}

set<pii> s;
unordered_map<int, unordered_set<int> > d;
pii temp;

void gen(int mx, int prev = 0, int p = 2) {
    if (p == 0) {
        s.emplace(temp);
        d[temp.fi].emplace(temp.se);
        d[temp.se].emplace(temp.fi);
        return;
    }
    for (int i = prev; i <= mx; i++) {
        if (p == 2) {
            temp.fi = i;
            gen(mx, i, 1);
        } else {
            temp.se = i;
            gen(mx, i, 0);
        }
    }
}

signed main() {
    Routine();
    int n, m;
    cin >> m >> n;
    gen(m);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        s.erase(minmax(a, b));
        d[a].erase(b);
        d[b].erase(a);
    }
    vector<deque<int> > ans;
    while (s.size()) {
        deque<int> f;
        f.pb(s.begin() -> fi);
        f.pb(s.begin() -> se);
        s.erase(s.begin());
        d[f.back()].erase(f.front());
        d[f.front()].erase(f.back());
        while (d[f.back()].size() || d[f.front()].size()) {
            if (d[f.back()].size()) {
                int x = *d[f.back()].begin();
                s.erase(minmax(x, f.back()));
                d[x].erase(f.back());
                d[f.back()].erase(x);
                f.pb(x);
            } else {
                int x = *d[f.front()].begin();
                s.erase(minmax(f.front(), x));
                d[x].erase(f.front());
                d[f.front()].erase(x);
                f.emplace_front(x);
            }
        }
        ans.pb(f);
    }
    cout << ans.size() << '\n';
    for (size_t i = 0; i < ans.size(); i++) {
        for (auto &c : ans[i]) {
            cout << c << ' ';
        }
        cout << -1 << '\n';
    }
    return 0;
}
