#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define pb emplace_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define INF 1e9
#define EPS 1e-4
#define MAXN int(1e6)
#define maxmin(x, y) mp(max(x, y), min(x, y))
#define elif else if

inline void Routine() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

template<class U, class T>
istream &operator >> (istream &in, pair<U, T> &p) {
    in >> p.fi >> p.se;
    return in;
}


template<class U, class T>
ostream &operator << (ostream &out, const pair<U, T> &p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template<class T>
istream &operator >> (istream &in, vector<T> &v) {
    for (auto &i : v) {
        in >> i;
    }
    return in;
}

template<class T>
ostream &operator << (ostream &out, const vector<T> &v) {
    for (auto &i : v) {
        out << i << ' ';
    }
    return out;
}

unordered_map<int, unordered_set<int> > d;
int m, temp = 0;

signed main() {
    //Routine();
    int n;
    cin >> m >> n;
    for (int i = 0; i <= m; i++) {
        for (int j = i; j <= m; j++) {
            d[i].emplace(j);
            d[j].emplace(i);
            temp++;
        }
    }
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        temp--;
        d[a].erase(b);
        d[b].erase(a);
    }
    vector<deque<int> > ans;
    vector<bool> fl(m);
    for (int i = 0; i < m; i++) {
        if (d[i].find(i) != d[i].end() && d[i].size() > 1) {
            d[i].erase(i);
            fl[i] = true;
            temp--;
        }
        if (d[i].size() == 0) {
            d.erase(i);
        }
    }
    while (temp) {
        deque<int> f;
        f.pb(d.begin() -> fi);
        f.pb(*(d.begin() -> se.begin()));
        d[f.back()].erase(f.front());
        d[f.front()].erase(f.back());
        temp--;
        while (d[f.back()].size() || d[f.front()].size()) {
            if (d[f.back()].size()) {
                int x = *d[f.back()].begin();
                d[x].erase(f.back());
                d[f.back()].erase(x);
                f.pb(x);
            } else {
                int x = *d[f.front()].begin();
                d[x].erase(f.front());
                d[f.front()].erase(x);
                f.emplace_front(x);
            }
            temp--;
        }
        for (auto &c : f) {
            if (d[c].empty()) {
                d.erase(c);
            }
        }
        ans.pb(f);
    }
    cout << ans.size() << '\n';
    for (size_t i = 0; i < ans.size(); i++) {
        for (auto &c : ans[i]) {
            cout << c << ' ';
            if (fl[c]) {
                cout << c << ' ';
                fl[c] = false;
            }
        }
        cout << -1 << '\n';
    }
    return 0;
}

