#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ll long long
#define ld long double

#define vi vector<int>

#define all(a) a.begin(), a.end()
#define pb push_back

using namespace std;

void dfs(int v, vi &dp, vector<bool> &was, vector<vi> &g, int f) {
    was[v] = true;

    int rep = 1;
    int c = -1;

    for(auto w : g[v]) {
        if(!was[w]) {
            dfs(w, dp, was, g, f);

            if(c < dp[w]) {
                c = dp[w];
                rep = 1;
            } else if(c == dp[w]) {
                rep++;
            }
        }
    }

    if(c == -1) {
        dp[v] = 1;
    } else if(c == 1) {
        dp[v] = 2;
    } else {
        if(rep == 1) dp[v] = c;
        else if(rep == 2 && v == f && g[v].size() == rep) dp[v] = c;
        else dp[v] = c+1;
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while(t > 0) {
        --t;

        int n;
        cin >> n;

        int answ = 1999999999;
        vector<vi> g(n);
        for(int i = 0; i < n-1; ++i) {
            int v, w;
            cin >> v >> w;

            g[v].pb(w);
            g[w].pb(v);
        }

        for(int j = 0; j < n; ++j) {
            vi dp(n, 1999999999);
            vector<bool> was(n, false);

            dfs(j, dp, was, g, j);
            answ = min(answ, dp[j]);
        }

        cout << answ << "\n";
    }
}
