#include <bits/stdc++.h>
using namespace std;

bool visited[100005];
int dp[100005];
vector <int> graf[100005];

void dfs(int v){
    visited[v] = 1;
    bool leaf = 1;
    vector <int> vec;
    for(auto c : graf[v]){
        if(!visited[c]){
            leaf = 0;
            dfs(c);
            vec.push_back(dp[c]);
        }
    }
    if(leaf){
        dp[v] = 1;
        return;
    }
    sort(vec.begin(), vec.end());
    int x = vec.size();
    int mx = vec[x-1];
    int l=0;
    while(mx >= vec[l]+1) l++;
    int sz = vec.size()-l;
    if(sz == 1 || (sz == 2 && v == 1)){
        dp[v] = max(2, mx);
    }
    else dp[v] = max(2, mx+1);
}

void solve(){
    int n;
    cin >> n;
    for(int i=1; i<=n; i++){
        graf[i].clear();
        visited[i] = 0;
    }
    for(int i=1; i<n; i++){
        int a, b;
        cin >> a >> b;
        a++;
        b++;
        graf[a].push_back(b);
        graf[b].push_back(a);
    }
    if(n == 1){cout << "1\n"; return;}
    int res = n;
    for(int i=1; i<=n; i++){
        for(int j=1; j<=n; j++){
            visited[j] = 0;
            dp[j] = 0;
        }
        dfs(i);
        cout << res << " " << dp[i] << endl;
        res = min(res, dp[i]);
    }
    cout << res << "\n";
}

int main(){

    int t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
