#include <bits/stdc++.h>
#define pb push_back
#define maxn 100005
using namespace std;
int t;
vector<int> graf[maxn];
bool bio[maxn];
int dep[maxn];
int podstabla[maxn];
void dfs(int x,int dub)
{
    bio[x] = 1;
    dep[x] = dub;
    podstabla[x] = 1;
    for(auto c:graf[x])
    {
        if(!bio[c])
            dfs(c,dub+1);
    }
    return;
}
int src;
int res;
void koliko(int x, int y, int pom,int par)
{
    if(pom >= y)
        res++;
    for(auto c:graf[x])
    {
        if(c!=par)
        koliko(c,y,pom+1,x);
    }
}
bool moze(int y, int n)
{
    for(int i=1; i<=n; i++)
    {
        int losih = 0;
        for(auto c:graf[i])
        {
            src = c;
            res = 0;
            koliko(c,y,0,i);
            if(res > 0)
                losih++;
        }
        if(losih >=3)
            return 0;
    }
    return 1;
}

void solve()
{
    int n;
    cin >> n;
    for(int i=1; i<=n; i++)
    {
        graf[i].clear();
        bio[i] = 0;
        dep[i]= 0;
    }
    for(int i=1; i<=n-1; i++)
    {
        int a,b;
        cin >> a >> b;
        graf[a+1].pb(b+1);
        graf[b+1].pb(a+1);
    }
    if(n == 1)
    {
        cout << 1 << endl;
        return;
    }
    dfs(1,1);

    int l = 2;
    int r = n;
    while(l < r)
    {
        int mid = (l+r)/2;
        if(moze(mid,n))
            r = mid;
        else
            l = mid+1;
    }
    cout << l << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin >> t;
    while(t--)
        solve();
    return 0;
}
