#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define pf push_front

int m, n;
bool povezano[1030][1030];
vector<int> graph[1030];
map<pair<int, int>, bool> visited;
int nodeVisited[1024];
deque<int> lanci[1030];
int br;

void dfs(int node, bool root, bool backOrFront)
{
    nodeVisited[node] = true;
    if(!backOrFront){
        lanci[br].pb(node);
    }
    else{
        lanci[br].pf(node);
    }

    int went = 0;
    for(auto c : graph[node]){
        if(!visited[{node,c}]){
            visited[{node,c}] = visited[{c,node}] = true;
            if(root){
                if(went == 0){
                    dfs(c, 0, 0);
                }
                else{
                    dfs(c, 0, 1);
                }
            }
            else{
                dfs(c, 0, backOrFront);
            }
            ++went;
            if(!root || went == 2){
                break;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> m >> n;

    for(int i = 0; i <= m; ++i){
        for(int j = 0; j <= m; ++j){
            povezano[i][j] = true;
        }
    }

    for(int i = 0; i < n; ++i){
        int a, b;
        cin >> a >> b;
        povezano[a][b] = povezano[b][a] = false;
    }

    for(int i = 0; i <= m; ++i){
        //cout << i << ": ";
        for(int j = 0; j <= m; ++j){
            if(povezano[i][j]){
                //cout << j << " ";
                graph[i].pb(j);
            }
        }
        //cout << "\n";
    }

    br = 0;
    for(int i = 0; i <= m; ++i){
        if(!nodeVisited[i]){
            dfs(i, 1, 0);
            ++br;
        }
    }

    for(int i = 0; i <= m; ++i){
        for(int j = 0; j <= m; ++j){
            if(povezano[i][j] && !visited[{i,j}]){
                lanci[br].pb(i);
                lanci[br++].pb(j);
                visited[{i,j}] = visited[{j,i}] = true;
            }
        }
    }

    cout << br << "\n";
    int lastOutput = -1;
    for(int i = 0; i < br; ++i){
        while(!lanci[i].empty()){
            int x = lanci[i].front();
            lanci[i].pop_front();
            cout << x << " ";
        }
        cout << -1 << "\n";
    }

    return 0;
}

/*
3 5
0 2
1 1
1 2
1 3
3 3

3 4
0 0
0 1
0 2
0 3
*/

