#include<iostream>
#include<vector>
#include<stack>
using namespace std;

const int maxi=100001;
vector<int> nList[maxi];
int vertices=0, edges;
bool passed[maxi];
bool finished[maxi];
stack<int> s1;
int maxl=0;

void init()
{
    for(int i=0; i<maxi; i++)
    {
        passed[i]=false;
        finished[i]=false;
        nList[i].clear();
    }
    maxl=0;
    cin>>edges;
    edges--;
    for(int i=0; i<edges; i++)
    {
        int v1, v2;
        cin>>v1>>v2;
        nList[v1].push_back(v2);
        nList[v2].push_back(v1);
    }
}

void DFS(int index)
{
    s1.push(index);
    passed[index]=true;
    while(s1.size()>0)
    {
        bool flag=true;
        int current=s1.top();
        for(int i=0; i<nList[current].size(); i++)
        {
            if(!passed[nList[current][i]])
            {
                passed[nList[current][i]]=true;
                flag=false;
                DFS(nList[current][i]);
            }
        }
        if(flag)
        {
            if(s1.size()>maxl)
            {
                maxl=s1.size();
            }
            finished[current]=true;
            //cout<<"current="<<current<<endl;
            s1.pop();
        }
    }
}

int main()
{
    int t;
    cin>>t;
    for(int i=0; i<t; i++)
    {
        init();
        DFS(0);
        cout<<maxl<<endl;
    }
}


/*
2
8
0 1
0 2
0 3
1 4
2 5
3 6
3 7
9
0 1
0 2
0 3
1 4
1 5
1 6
3 7
3 8
*/
