#include<iostream>
#include<queue>
#include<vector>
#include<algorithm>

using namespace std;

const int maxn = 100005;
const int T = 11;
vector<int> adj[maxn][T];
bool used[maxn];
//int len[maxn];
queue<int> bfs;
int n, t;
int snr[maxn];
//pair<int, int> minn[maxn][T];

//pair<int, int> BFS(int v){
//    ///cout << "v: " << v << "   ";
//    bfs.push(v);
//    used[v] = true;
//    len[v]=0;
//    pair<int, int> maxx = make_pair(0, v);
//    while(!bfs.empty()){
//        int cur = bfs.front();
//        bfs.pop();
//        for(int i=0; i<adj[cur][t].size(); i++){
//            int neighbour = adj[cur][t][i];
//            if(!used[neighbour]){
//                bfs.push(neighbour);
//                used[neighbour] = true;
//                len[neighbour] = len[cur]+1;
//                if(maxx.first < len[neighbour]){
//                    maxx.first = len[neighbour];
//                }
//            }
//        }
//    }
//    for(int i=0; i<n; i++){
//        used[i]=0;
//        len[i]=0;
//    }
//    ///cout << "maxx: " << maxx << endl;
//    return maxx;
//}

int BFS_2(int v){
    int ans;
    bfs.push(v);
    used[v] = true;
    snr[v]=0;
    while(!bfs.empty()){
        int cur = bfs.front();
        bfs.pop();
        for(int i=0; i<adj[cur][t].size(); i++){
            int neighbour = adj[cur][t][i];
            if(!used[neighbour]){
                if(cur==v || adj[cur][t].size()>2){
                    snr[neighbour]=1;
//                    if(v==1){
//                        cout << neighbour << ":  " << snr[neighbour] << "   #1" << endl;
//                    }
                }
                else{
                    if(adj[cur][t].size()==2){
                        snr[neighbour]=snr[cur]+1;
//                        if(v==1){
//                            cout << neighbour << ":  " << snr[neighbour] << "   #2" << endl;
//                        }
                    }
                }
                bfs.push(neighbour);
                used[neighbour] = true;

//                if(neighbour==4 && v==1){
//                    cout << "HERE:  " << adj[cur][t].size() << "HERE 2:  " << cur << endl;
//                }
            }
        }
    }
    sort(snr, snr+n);
    if(snr[n-1]==snr[n-2]){
        ans = snr[n-1];
    }
    else{
        ans = snr[n-2];
    }

    for(int i=0; i<n; i++){
        used[i]=0;
        snr[i]=0;
    }
    ///cout << "v: " << v << "   snr: " << ans << endl;
    return ans;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int tests;
    cin >> tests;

    for(t=0; t<tests; t++){
        cin >> n;
        for(int i=1; i<n; i++){
            int a, b;
            cin >> a >> b;
            adj[a][t].push_back(b);
            adj[b][t].push_back(a);
        }

//        for(int i=0; i<n; i++){
//            minn[i][t] = BFS(i);
//        }
//        sort(minn[t], minn[t]+n);
//        int answer = BFS_2(minn[0][t].second);
//        for(int j=0; minn[0][t].first==minn[j][t].first; j++){
//            int note = BFS_2(minn[j][t].second);
//            answer = min(answer, note);
//        }
        int answer = -10;
        for(int j=0; j<n; j++){
            if(adj[j][t].size()==1) continue;
            int note = BFS_2(j);
            answer = max(answer, note);
        }

        cout << answer+1 << endl;
    }
    return 0;
}
/*
2
8
0 1
0 2
0 3
1 4
2 5
3 6
3 7
9
0 1
0 2
0 3
1 4
1 5
1 6
3 7
3 8
*/


