#include <bits/stdc++.h>
#include "namuhs.h"
#define MAXN 100003
using namespace std;
bool compare_segments(int left1, int right1, int left2, int right2);
pair <int, int> solve(int left, int right)
{
    if (left == right)
        return make_pair(left, right);
    int mid = (left + right) >> 1;
    auto first = solve(left, mid);
    auto second = solve(mid+1, right);
    auto ans = first;
    if (compare_segments(second.first, second.second, ans.first, ans.second))
        ans = second;
    vector <pair <int, int> > seg1;
    vector <pair <int, int> > seg2;
    for (int i = mid; i >= left; i--)
        seg1.push_back(make_pair(i, mid));
    for (int i = mid+1; i <= right; i++)
        seg2.push_back(make_pair(mid+1, i));
    auto best_ans_suffix = seg1[0];
    auto best_ans_preffix = seg2[0];
    random_shuffle(seg1.begin(), seg1.end());
    random_shuffle(seg2.begin(), seg2.end());
    for (auto i: seg1)
        if (compare_segments(i.first, i.second, best_ans_suffix.first, best_ans_suffix.second))
        best_ans_suffix = i;
    for (auto i: seg2)
        if (compare_segments(i.first, i.second, best_ans_preffix.first, best_ans_preffix.second))
        best_ans_preffix = i;
    if (compare_segments(best_ans_suffix.first, best_ans_preffix.second, ans.first, ans.second))
        ans = make_pair(best_ans_suffix.first, best_ans_preffix.second);
    return ans;
}
void find_max(int n, int &left, int &right)
{
    auto best = solve(1, n);
    left = best.first;
    right = best.second;
}
