#include <bits/stdc++.h>
#define MAXN 1024
#define endl '\n'
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
int m, n;
bool used[MAXN][MAXN];
void read()
{
    cin >> m >> n;
    for (int i = 1; i <= n; i++)
    {
        int a, b;
        cin >> a >> b;
        used[a][b] = true;
        used[b][a] = true;
    }
}
vector <pair <int, int> > all;
vector <pair <int, int> > check(vector <pair <int, int> > group)
{
    sort (group.begin(), group.end());
    do
    {
        bool is = true;
        for (int i = 1; i < group.size(); i++)
            if (group[i-1].second != group[i].first)
            {
                is = false;
                break;
            }
        if (is)
            return group;
    }
    while (next_permutation(group.begin(), group.end()));
    return vector <pair <int, int> > ();
}
int min_ans = 1000000000;
vector <vector <pair <int, int> > > groups;
vector <vector <pair <int, int> > > ans;
void brute_force(int idx)
{
    if (idx == all.size())
    {
        bool is = true;
        for (auto i: groups)
            if (check(i).empty())
        {
            is = false;
            break;
        }
        if (is && groups.size() < min_ans)
        {
            min_ans = groups.size();
            ans = groups;
        }
        return;
    }
    if (used[all[idx].first][all[idx].second])
        brute_force(idx+1);
    for (auto i: groups)
    {
        i.push_back(all[idx]);
        brute_force(idx+1);
        i.pop_back();
        i.push_back(make_pair(all[idx].second, all[idx].first));
        brute_force(idx+1);
        i.pop_back();
    }
    vector <pair <int, int> > temp;
    temp.push_back(all[idx]);
    groups.push_back(temp);
    brute_force(idx+1);
    groups.pop_back();
    temp.clear();
    temp.push_back(make_pair(all[idx].second, all[idx].first));
    groups.push_back(temp);
    brute_force(idx+1);
    groups.pop_back();
}
void solve()
{
    for (int i = 0; i <= m; i++)
        for (int j = i; j <= m; j++)
        all.push_back(make_pair(i, j));
    brute_force(0);
    cout << min_ans << endl;
    for (auto i: groups)
    {
        cout << i[0].first << " ";
        for (auto j: i)
            cout << j.second << " ";
        cout << -1 << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}

