#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100003
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
int t;
int n;
vector <int> adj[MAXN];
int best_to[MAXN];
int best[MAXN];
void dfs(int ver, int par)
{
    best[ver] = best_to[ver] = 0;
    int max1 = 0, max2 = 0;
    for (auto i: adj[ver])
        if (i != par)
    {
        dfs(i, ver);
        best[ver] = max(best[ver], best[i]);
        if (best_to[i] > max1)
        {
            max2 = max1;
            max1 = best_to[i];
        }
        else
            if (best_to[i] > max2)
        max2 = best_to[i];
    }
    best_to[ver] = max1 + 1;
    best[ver] = max(best[ver], max1 + max2);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> t;
    for (int i = 1; i <= t; i++)
    {
        cin >> n;
        for (int i = 0; i < n; i++)
            adj[i].clear();
        for (int i = 1; i < n; i++)
        {
            int a, b;
            cin >> a >> b;
            adj[a].push_back(b);
            adj[b].push_back(a);
        }
        dfs(0, -1);
        cout << best[0] - 1 << endl;
    }
}
