#include<bits/stdc++.h>

using namespace std;

const int MAXM = 1024 + 7;

bool edge[MAXM][MAXM];
int where[MAXM];
int cnt[MAXM];
int m;
vector<vector<int> > res;

vector<int> empty_vector;

void dfs2(int v)
{
    res.back().push_back(v);

    for(int i = where[v]; i <= m; i++)
    {
        where[v]++;

        if(edge[i][v])
        {
            edge[i][v] = false;
            edge[v][i] = false;

            cnt[v]--;
            if(v != i)
                cnt[i]--;

            dfs2(i);
        }
    }
}

void dfs(int v)
{
    bool b = false;

    for(int i = where[v]; i <= m; i++)
    {
        where[v]++;
        if(i == v)
            continue;

        if(edge[i][v])
        {
            edge[i][v] = false;
            edge[v][i] = false;
            cnt[i]--;
            cnt[v]--;

            if(b)
            {
                reverse(res.back().begin(), res.back().end());

                dfs2(i);
                b = false;

                if(cnt[v])
                    res.push_back(empty_vector);
            }
            else
            {
                b = true;

                res.back().push_back(v);
                if(edge[v][v])
                {
                    edge[v][v] = false;
                    res.back().push_back(v);
                    cnt[v]--;
                }

                dfs2(i);
            }
        }
    }
}

int main ()
{
    int n;

    cin >> m >> n;

    for(int i = 0; i <= m; i++)
        for(int j = 0; j <= m; j++)
            edge[i][j] = 1;

    for(int i = 0; i <= m; i++)
        cnt[i] = m+1;

    for(int i = 0; i < n; i++)
    {
        int u, v;

        cin >> u >> v;

        edge[u][v] = false;
        edge[v][u] = false;

        cnt[u]--;
        if(v != u)
            cnt[v]--;
    }

    for(int i = 0; i <= m; i++)
        if(cnt[i])
        {
            res.push_back(empty_vector);
            dfs(i);
        }

    if(res.empty())
    {
        cout << "0\n";

        return 0;
    }

    cout << res.size() << "\n";

    for(int i = 0; i < res.size(); i++)
    {
        for(int j = 0; j < res[i].size(); j++)
            cout << res[i][j] << " ";
        cout << "-1\n";
    }

    return 0;
}
/*
3 5
0 2
1 1
1 2
1 3
3 3
*/
