#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;

vector<int> adj[MAXN];
map<int, int> mp;
vector<pair<int, int> > edges;

int dfs(int v, int p = -1)
{
    int mx1 = 0, mx2 = 0;

    for(int to: adj[v])
    {
        if(to == p)
            continue;

        int curr = dfs(to, v);

        if(curr >= mx1)
        {
            mx2 = mx1;
            mx1 = curr;
        }
        else
            if(curr >= mx2)
                mx2 = curr;
    }

    if(mx1 == 0)
        return 1;

    return max(max(mx1-1, mx2)+1, 2);
}

void solve()
{
    int n;

    cin >> n;

    for(int i = 1; i <= n; i++)
        adj[i].clear();
    mp.clear();
    edges.clear();

    for(int i = 0; i < n-1; i++)
    {
        int u, v;

        cin >> u >> v;

        adj[u].push_back(v);
        adj[v].push_back(u);
        edges.push_back({u, v});
    }

    if(n == 1)
    {
        cout << "1\n";

        return;
    }

    cout  << "3\n";


    return;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t;

    cin >> t;

    while(t--)
        solve();

    return 0;
}
