#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;

vector<int> adj[MAXN];
map<int, int> mp;
vector<pair<int, int> > edges;

int dfs(int v, int p = -1, bool start = false)
{
    int mx1 = 0, mx2 = 0, mx3 = 0, mx4;

    for(int to: adj[v])
    {
        if(to == p)
            continue;

        int curr = dfs(to, v);

        //cout << curr << "  -- " << v << endl;

        if(curr >= mx1)
        {
            mx4 = mx3;
            mx3 = mx2;
            mx2 = mx1;
            mx1 = curr;
        }
        else
        {
            if(curr >= mx2)
            {
                mx4 = mx3;
                mx3 = mx2;
                mx2 = curr;
            }
            else
            {
                if(curr >= mx3)
                {
                    mx4 = mx3;
                    mx3 = curr;
                }
                else
                    if(curr >= mx4)
                        mx4 = mx3;
            }
        }
    }

    if(mx1 == 0)
        return 1;

    if(start)
        return max(mx1, 2);

    return max(max(mx1-1, mx2)+1, 2);
}

void solve()
{
    int n;

    cin >> n;

    for(int i = 0; i < n; i++)
        adj[i].clear();
    mp.clear();
    edges.clear();

    for(int i = 0; i < n-1; i++)
    {
        int u, v;

        cin >> u >> v;

        adj[u].push_back(v);
        adj[v].push_back(u);
        edges.push_back({u, v});
    }

    if(n == 1)
    {
        cout << "1\n";

        return;
    }

    int res = dfs(0, -1, true);

    //for(int i = 1; i < n; i++)
    //    res = min(dfs(i, -1, true), res);

    cout << res << "\n";

    return;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t;

    cin >> t;

    while(t--)
        solve();

    return 0;
}
