#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 100000;

int n;
vector<int> g[MAXN];

void read() {
	cin >> n;
	for (int i = 0; i < n; i++) g[i].clear();
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
}

int timestamp = 0;
int used[MAXN];

int bfs(int node) {
	timestamp++;
	queue<pair<int, int>> q;
	int ans = 0;
	q.push({node, 1});
	used[node] = timestamp;
	while (!q.empty()) {
		pair<int, int> curr = q.front();
		q.pop();
		chkmax(ans, curr.second);
		for (int adj : g[curr.first]) {
			if (used[adj] != timestamp) {
				used[adj] = timestamp;
				q.push({adj, curr.second + 1});
			}
		}
	}
	return ans;
}

void solve() {
	memset(used, 0, sizeof(used));
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		read();
		cout << bfs(0) << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	solve();

	return EXIT_SUCCESS;
}
