#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 1025;

int m, n;
int cntCells;
bool erased[MAXN][MAXN];

void read() {
	cin >> m >> n;
	for (int i = 1; i <= n; i++) {
		int a, b;
		cin >> a >> b;
		erased[a][b] = erased[b][a] = true;
	}
	cntCells = ((m + 1) * (m + 2)) >> 1;
	cntCells -= n;
}

bool used[MAXN][MAXN];
int cntAns = INT_MAX;
vector<vector<int>> ans;

void F(int cntUsed, vector<vector<int>> state, vector<int> cycle) {
	if (cntUsed == cntCells) {
		if (!cycle.empty()) state.push_back(cycle);
		if (chkmin(cntAns, state.size())) ans = state;
		return;
	}
	if (!cycle.empty()) {
		for (int i = 0; i <= m; i++) {
			if (!erased[cycle.back()][i] && !used[cycle.back()][i]) {
				used[cycle.back()][i] = true;
				used[i][cycle.back()] = true;
				cycle.push_back(i);
				F(cntUsed + 1, state, cycle);
				cycle.pop_back();
				used[cycle.back()][i] = false;
				used[i][cycle.back()] = false;
			}
		}
		//state.push_back(cycle);
	}
	/*
	for (int i = 0; i < m; i++) {
		for (int j = i; j < m; j++) {
			if (!era3 5
0 2
1 1
1 2
1 3
3 3sed[i][j] && !used[i][j]) {
				used[i][j] = true;
				used[j][i] = true;
				F(cntUsed + 1, state, {i, j});
				used[i][j] = false;
				used[j][i] = false;
			}
			if (!erased[j][i] && !used[j][i]) {
				used[i][j] = true;
				used[j][i] = true;
				F(cntUsed + 1, state, {j, i});
				used[i][j] = false;
				used[j][i] = false;
			}
		}
	}
	*/
}

void solve() {
	memset(used, false, sizeof(used));
	ans.clear();
	F(0, {}, {});
	cout << cntAns << endl;
	for (int i = 0; i < ans.size(); i++) {
		for (int j = 0; j < ans[i].size(); j++) cout << ans[i][j] << ' ';
		cout << "-1\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	read();
	solve();

	return EXIT_SUCCESS;
}
