#include <iostream>
#include "namuhs.h"
using namespace std;

const int MAXN = 100100;///100 000
struct lrDt {
	int l, r;
};
int dt[MAXN];

void find_max(int N, int& left, int& right) {
	///generate Left and Right indexes
	int currMaxL = 1;
	int currMaxR = 1;
	dt[1].l = 1;
	dt[1].r = 1;
	for(int i = 2;i <= N; ++i) {
		int lastL = dt[i - 1].l;
		int lastR = dt[i - 1].r;
		if(compare_segments(i, i, lastL, lastR)) {
			if(compare_segments(i, i, lastL, i)) {
				dt[i].l = i;
				dt[i].r = i;
			}
			else {
				dt[i].l = lastL;
				dt[i].r = i;
			}
		}
		else {
			if(compare_segments(lastL, lastR, lastL, i)) {
				dt[i].l = lastL;
				dt[i].r = lastR;
			}
			else {
				dt[i].l = lastL;
				dt[i].r = i;
			}
		}
	}
	left = dt[N].l;
	right = dt[N].r;
	return;
}
