#include <iostream>
#include <vector>
using namespace std;

int t;
int n;
const int MAXN = 100100;///100 000
int minAns = 1000000;///INF

vector <int> children[MAXN];

void dfc(int index, int currAns) {
	if(children[index].size() == 0) {
		if(currAns < minAns)
			minAns = currAns;
		return;
	}
	for(int i = 0;i < children[index].size(); ++i) {
		dfc(children[index][i], currAns + 1);
	}
	return;
}

int main() {
	cin >> t;
	for(int ti = 0;ti < t; ++ti) {
		cin >> n;
		for(int i = 0;i < n; ++i) {
			children[i].clear();
		}
		for(int i = 0;i < n - 1; ++i) {
			int from, to;
			cin >> from >> to;
			if(from > to)
				swap(from, to);
			children[from].push_back(to);
		}
		minAns = 1000000;
		dfc(0, 1);
		cout << minAns << endl;
	}

	return 0;
}
