#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e5+10;
const int inf=1e9+2137;

bool odw[MAXN];
int dist[MAXN];
int last[MAXN];
queue<int> q;
vector<int> vec[MAXN];

void dfs(int node)
{
    odw[node]=true;
    for(int i=0;i<vec[node].size();i++)
    {
        if(odw[vec[node].at(i)]==false)
        {
            odw[vec[node].at(i)]=true;
            last[vec[node].at(i)]=node;
            dist[vec[node].at(i)]=dist[node]+1;
            dfs(vec[node].at(i));
        }
    }
}

void get_path(int node)
{
    while(last[node]!=node)
    {
        odw[node]=true;
        q.push(node);
        node=last[node];
    }
    q.push(node);
}

void bfs()
{
    while(q.empty()==false)
    {
        int node=q.front();
        q.pop();
        for(int i=0;i<vec[node].size();i++)
        {
            if(odw[vec[node].at(i)]==false)
            {
                odw[vec[node].at(i)]=true;
                dist[vec[node].at(i)]=dist[node]+1;
                q.push(vec[node].at(i));
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t,i,j,l,in,n,a,b,node,mx,ans;
    cin>>t;
    for(j=0;j<t;j++)
    {
        cin>>n;
        for(i=0;i<n-1;i++)
        {
            cin>>a>>b;
            vec[a].push_back(b);
            vec[b].push_back(a);
        }
        dfs(0);
        mx=-1;
        node=-1;
        for(i=0;i<n;i++)
        {
            if(dist[i]>mx)
            {
                mx=dist[i];
                node=i;
            }
            dist[i]=0;
            odw[i]=false;
            last[i]=0;
        }
        dfs(node);
        last[node]=node;
        mx=-1;
        node=-1;
        for(i=0;i<n;i++)
        {
            if(dist[i]>mx)
            {
                mx=dist[i];
                node=i;
            }
            dist[i]=0;
            odw[i]=false;
        }
        get_path(node);
        bfs();
        ans=0;
        for(i=0;i<n;i++)
        {
            vec[i].clear();
            ans=max(ans,dist[i]);
            odw[i]=false;
            dist[i]=0;
            last[i]=0;
        }
        cout<<ans+1<<"\n";
    }
}

