#include <cstdio>
#include <vector>

#define MAXM 1024

using namespace std;

vector<int> v[MAXM+5];
vector<int> sol[MAXM+5];
bool t[MAXM+5][MAXM+5], self[MAXM+5], viz[MAXM+5];
int d1[MAXM+5], d2[MAXM+5], lm;

inline void reset( int lim )
{
	for( int i=0;i<=lim;i++ )
		d1[i]=d2[i]=viz[i];
}

void bfs( int &d, int b, int f[], int l )
{
	f[b]=l;

	int ok=0;

	for( vector<int>::iterator it=v[b].begin();it!=v[b].end();it++ )
		if( f[*it]==0 )
		{
			bfs(d,*it,f,l+1);
			ok=1;
		}

	if( !ok && l>lm )
	{
	  lm=l;
		d=b;
	}
}

inline void rec( int b, int d, int p )
{
	while( b!=d )
	{
		viz[b]=(v[b].size()<=2);

		sol[p].push_back(b);

		if( self[b] )
		{
			self[b]=0;
			sol[p].push_back(b);
		}

		for( vector<int>::iterator it=v[b].begin();it!=v[b].end();it++ )
			if( d2[*it]==d2[b]-1 && !viz[*it] )
			{
				b=*it;
				break;
			}
	}

	sol[p].push_back(d);

	if( self[d] )
	{
		sol[p].push_back(d);
		self[d]=0;
	}

	viz[d]=(v[d].size()<=2);
}

int main()
{
	int n, m;

	scanf( "%d%d", &n, &m );

	for( int i=1;i<=m;i++ )
	{
		int a, b;

		scanf( "%d%d", &a, &b );

		if( a<b )
			t[a][b]=1;
		else
			t[b][a]=1;
	}

	for( int i=0;i<=n;i++ )
		for( int j=i;j<=n;j++ )
			if( !t[i][j] )
			{
				if( i==j )
					self[i]=1;
				else
				{
					v[i].push_back(j);
					v[j].push_back(i);
				}
			}
			else
				t[i][j]=0;

	int ans=0;

	for( int i=0;i<=n;i++ )
		if( !viz[i] )
		{
			reset(m);

			int nod1, nod2;

			lm=0;

			bfs(nod1,i,d1,1);

			lm=0;

			bfs(nod2,nod1,d2,1);

			rec(nod2,nod1,++ans);
		}

	printf( "%d\n", ans );

	for( int i=1;i<=ans;i++ )
	{
		for( vector<int>::iterator it=sol[i].begin();it!=sol[i].end();it++ )
			printf( "%d ", *it );

		printf( "-1\n" );
	}

	return 0;
}
