#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

const int N=100000+5;

int n;
vector<int>g[N];
int dp[N];
bool viz[N];

inline void dfs(int nod)
{
    viz[nod]=1;
    vector<int>x;
    for(auto &nou:g[nod])
    {
        if(viz[nou]==0)
        {
            dfs(nou);
            x.push_back(dp[nou]);
        }
    }
    sort(x.begin(),x.end());
    if(x.size()==0)
    {
        dp[nod]=1;
        return;
    }
    dp[nod]=2;
    if(x[0]==x.back())
    {
        dp[nod]=x.back()+1;
    }
    else
    {
        dp[nod]=x.back();
    }
}

inline int slove(int nod)
{
    for(int i=1;i<=n;i++)
    {
        viz[i]=0;
        dp[i]=-1;
    }
    dfs(nod);
    return dp[nod];
}

int main()
{
    //freopen("input","r",stdin);
    //freopen("output","w",stdout);
    int t;
    cin>>t;
    for(int tc=1;tc<=t;tc++)
    {
        cin>>n;
        for(int i=1;i<=n;i++)
        {
            g[i].clear();
        }
        for(int i=1;i<n;i++)
        {
            int a,b;
            cin>>a>>b;
            a++;
            b++;
            g[a].push_back(b);
            g[b].push_back(a);
        }
       /// cout<<"\t\t\t";
        cout<<slove(1)<<"\n";
    }
    return 0;
}
