#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

const int N = 1e5 + 7;

bool viz[N];
int ans;

vector < int > v[N];

void dfs(int nod = 0, int t = 0, int& sz) {
    if (v[nod].size() == 1) {
        sz = 1;
        return;
    }
    int max1(-1), max2(-1);
    for (auto i : v[nod]) {
        if (i != t) {
            int x;
            dfs(i, nod, x);
            if (x > max1) {
                max2 = max1;
                max1 = x;
            }
            else if (x > max2) {
                max2 = x;
            }
        }
    }
    ans = max(ans, max2);
    return aux;
}

int main()
{
    int t;
    cin >> t;
    while (t--) {
        int n, a, b;
        cin >> n;
        for (int i = 0; i < n; ++i)
            v[i].clear();
        for (int i = 1; i < n; ++i) {
            cin >> a >> b;
            v[a].push_back(b);
            v[b].push_back(a);
        }
        if (n == 1) {
            cout << "1\n";
            continue;
        }
        ans = 0;
        dfs();
        cout << ans << '\n';
    }
    return 0;
}
