#include <iostream>
#include "namuhs.h"

void solve(int from ,int to , int &x ,int &y , int &suff , int &pref){
  if(from == to)
    x = y = suff = pref = from;
  else {
    int mid = (from + to) / 2;
    int x2 , y2 , suff2 , pref2;
    int x3 , y3 , suff3 , pref3;
    solve(from , mid , x2 , y2, suff2 , pref2);
    solve(mid + 1 , to , x3 , y3 , suff3 , pref3);
    if(compare_segments(x2 , y2 , x3 , y3) == 1) {
      x = x2;
      y = y2;
    } else {
      x = x3;
      y = y3;
    }

    if(compare_segments(from , pref2 , from , pref3) == 1)
      pref = pref2;
    else
      pref = pref3;

    if(compare_segments(suff2 , to , suff3 , to) == 1)
      suff = suff2;
    else
      suff = suff3;

    if(compare_segments(x , y , suff2 , pref3) == 0) {
      x = suff2;
      y = pref3;
    }

  }
}

void find_max(int N, int& left, int& right){
  int x , y , suff , pref;
  solve(1 , N , x , y , suff , pref);
  left = x;
  right = y;
}
