#include <bits/stdc++.h>

#define NM 1030
#define MM 2000002

using namespace std;

struct Edge
{
    int u, v, viz;
    int other(int u)
    {
        return this->u + this->v - u;
    }
};

Edge edges[MM];
bool ie[NM][NM];

int g[NM];

vector <Edge*> gr[NM];

int n, m;

vector <int> eul;

void euler(int u)
{
    eul.push_back(u);
    for(auto e : gr[u])
        if(e->viz == 0)
        {
            e->viz = 1;
            euler(e->other(u));
            if(eul.back() != u)
                break;
        }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    n++;
    for(int i = 1; i <= m; i++)
    {
        int a, b;
        cin >> a >> b;
        ie[a][b] = ie[b][a] = 1;
    }
    m = 0;
    for(int i = 0; i < n; i++)
        for(int j = i; j < n; j++)
            if(!ie[i][j])
            {
                m++;
                edges[m].u = i;
                edges[m].v = j;
                gr[i].push_back(&edges[m]);
                gr[j].push_back(&edges[m]);
                g[i]++;
                g[j]++;
            }
    int ans = 0;
    for(int i = 1; i <= m; i++)
        if(g[edges[i].u] == 1 || g[edges[i].v] == 1 && edges[i].viz == 0)
        {
            if(g[edges[i].u] == 1)
                euler(edges[i].u);
            else
                euler(edges[i].v);
            eul.push_back(-1);
            ans++;
        }
    for(int i = 1; i <= m; i++)
        if(edges[i].viz == 0)
        {
            euler(edges[i].u);
            eul.push_back(-1);
            ans++;
        }
    cout << ans << "\n";
    for(auto i : eul)
    {
        cout << i << " ";
        if(i == -1)
            cout << "\n";
    }
    return 0;
}
