#include <bits/stdc++.h>

using namespace std;

const int NMAX=1e5+5;

vector <int> G[NMAX];

int T, t, N, i, X, Y, Level[NMAX];

bool Sel[NMAX];

void BFS (int node)
{
    queue <int> Q;

    Q.push(node);

    while(!Q.empty())
    {
        int j=Q.front();

        Sel[j]=true;

        for(int i=0; i<G[j].size(); ++i)
            if(!Sel[G[j][i]])
            {
                Q.push(G[j][i]);

                Level[G[j][i]]=Level[j]+1;
            }

        Q.pop();
    }
}

int main()
{
    cin.tie(NULL);

    cin>>T;

    for(t=1; t<=T; ++t)
    {
        cin>>N;

        for(i=0; i<=N; ++i)
        {
            Sel[i]=false;

            if(!G[i].empty())
                G[i].clear();

            Level[i]=0;
        }

        for(i=1; i<N; ++i)
        {
            cin>>X>>Y;

            G[X].push_back(Y);
            G[Y].push_back(X);
        }

        Level[0]=1;

        BFS(0);

        int ans=INT_MIN;

        for(i=0; i<N; ++i)
            ans=max(ans, Level[i]);

        cout<<ans<<'\n';

    }

    return 0;
}
