#include <bits/stdc++.h>

using namespace std;

const int NMAX=1e5+5;

vector < pair <int, int> > G[NMAX];

int Sol[NMAX], Sel[NMAX];

int T, t, N, i, j, X, Y, ans;

priority_queue < pair<int, int>, vector<pair <int, int> >, greater < pair< int, int> > > H;

void Dijkstra (int node)
{
    for(int i=0; i<N; ++i)
    {
        Sel[i]=false;

        Sol[i]=-1;
    }

    Sel[node]=true;
    Sol[node]=0;

    for(int i=0; i<G[node].size(); ++i)
    {
        Sol[G[node][i].first]=G[node][i].second;

        H.push({G[node][i].second, G[node][i].first});
    }

    int cnt=G[node].size();

    while(cnt)
    {
        while(Sel[H.top().second]==true)
            H.pop();

        int nod=H.top().second;
        Sel[nod]=true;
        --cnt;
        H.pop();

        for(int i=0; i<G[nod].size(); ++i)
        {
            int j=G[nod][i].first;

            if(Sol[j]==-1)
            {
                Sol[j]=Sol[nod]+G[nod][i].second;

                H.push({Sol[j], j});

                ++cnt;
            }
            else if( Sol[nod] + G[nod][i].second < Sol[j])
            {
                Sol[j]=Sol[nod]+G[nod][i].second;

                H.push({Sol[j], j});
            }
        }
    }

    for(int i=0; i<N; ++i)
        ans=max(ans, Sol[i]);
}

int main()
{
    cin.tie(NULL);

    cin>>T;

    for(t=1; t<=T; ++t)
    {
        cin>>N;

        for(i=0; i<N; ++i)
        {
            if(!G[i].empty())
                G[i].clear();

            Sol[i]=-1;
            Sel[i]=0;
        }

        for(i=0; i<N-1; ++i)
        {
            cin>>X>>Y;

            G[X].push_back({Y, 1});
            G[Y].push_back({X, 1});
        }

        ans=INT_MIN;

        for(i=0; i<N; ++i)
            Dijkstra(i);

        cout<<--ans<<'\n';
    }

    return 0;
}
