#include <iostream>
#include <string>
#include <algorithm>
#include <cstring>
#include <vector>
#include <cstdio>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <utility>
#include <random>
#include <ctime>

#pragma comment(linker, "/STACK:256000000")
#pragma warning(disable:4996)
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")

using namespace std;

typedef long long ll;
const char el = '\n';
const int inf = 1e9, mod = (int)(1e9) + 7;
const ll llinf = 1e18;

#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define x first
#define y second

mt19937 rnd(time(0));

int n;
int g[1025][1025];
vector<vector<int>> ans;
vector<int> ord, st;

bool dfs(int v, int circ = -1) {
	int cnt = 0;
	forn(to, n) {
		if (g[v][to] == 1) {
			if (circ == -1) {
				st[v]--; st[to]--;
				g[v][to] = g[to][v] = 2;
				dfs(to);
				ord.push_back(v);
				g[v][to] = g[to][v] = 0;
				cnt++;
				if (!(st[v] & 1))
				circ = v;
				else break;
			}
			else {
				st[v]--; st[to]--;
				g[v][to] = g[to][v] = 2;
				if (!dfs(to, circ)) {
					st[v]++; st[to]++;
					g[v][to] = g[to][v] = 1;
					continue;
				}
				ord.push_back(v);
				g[v][to] = g[to][v] = 0;
				cnt++;
				if (!(st[v] & 1))
					circ = v;
				else break;
			}
		}
	}
	if (!cnt) {
		if (circ >= 0) {
			if (circ == v) {
				return true;
			}
			return false;
		}
		ord.push_back(v);
		return true;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int m;
	cin >> n >> m;
	n++;
	forn(i, n)
		forn(j, n)
		g[i][j] = 1;
	st.assign(n, n - 1);
	vector<bool> zp(n, 0);
	forn(i, n) g[i][i] = 0;
	forn(i, m) {
		int v, u;
		cin >> v >> u;
		if (v != u) {
			st[v]--; st[u]--;
			g[v][u] = g[u][v] = 0;
		}
		else zp[v] = 1;
	}
	forn(i, n)
	if (!zp[i] && st[i] == 0) {
		vector<int> tmp(2, i);
		ans.push_back(tmp);
		zp[i] = 1;
	}
	forn(i, n) {
		if (st[i] & 1) {
			dfs(i);
			ans.push_back(vector<int>());
			ans.back().resize(ord.size());
			copy(all(ord), ans.back().begin());
			ord.clear();
		}
	}
	forn(i, n) {
		if (st[i] > 0) {
			dfs(i, i);
			ans.push_back(vector<int>());
			ans.back().resize(ord.size());
			copy(all(ord), ans.back().begin());
			ord.clear();
		}
	}
	cout << (int)ans.size() << el;
	forn(i, ans.size()) {
		for (auto j : ans[i]) {
			cout << j << ' ';
			if (!zp[j]) {
				cout << j << ' ';
				zp[j] = 1;
			}
		}
		cout << "-1\n";
	}
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}
