#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;
const int LG = 20;

int n;
int cnt[MAXN];
vector <int> g[MAXN];

int dfs(int u, int parent) {
    int ans = 0;
    int p = 0;
    cnt[u] = 1;
    for (int v : g[u]) {
        if (v == parent) continue;
        ans = max(ans, dfs(v, u));
        cnt[u] += cnt[v];
        p += (cnt[v] > 1);
    }
    return max(p, ans);
}

mt19937 rnd(228);
void solve() {
    for (int i = 0; i < MAXN; ++i) {
        g[i].clear();
    }
    cin >> n;

    if (n == 1) {
        cout << "1\n";
        return;
    }

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int ans = 0;
    for (int i = 0; i < LG; ++i) {
        int u = rnd() % n;
        ans = max(ans, dfs(u, u));
    }
    cout << ans << '\n';
}

signed main() {
    freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();

    return 0;
}
