#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 7;

int dp[MAXN];
vector <int> g[MAXN];

const int INF = 1e9 + 7;

void dfs(int u, int parent) {
    int mx = -INF;
    int mn = INF;
    for (int v : g[u]) {
        if (v == parent) continue;
        dfs(v, u);
        mx = max(mx, dp[v]);
        mn = min(mn, dp[v]);
    }
    if (mn == INF) {
        dp[u] = 1;
    }
    else {
        dp[u] = max(mx, mn + 1);
    }
}

void solve() {
    for (int i = 0; i < MAXN; ++i) g[i].clear();
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, 0);
    cout << dp[0] << '\n';
}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();

    return 0;
}
