#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2007;

set <int> g[MAXN];
bool del[MAXN][MAXN];

vector <vector <int> > ans;

void dfs(int u) {
    if (g[u].find(u) != g[u].end()) {
        ans.back().push_back(u);
        g[u].erase(u);
    }
    int v = -1;
    while (1) {
        auto t = upper_bound(g[u].begin(), g[u].end(), v);
        if (t == g[u].end()) break;
        int v = *t;
        ans.back().push_back(v);
        g[u].erase(v);
        g[v].erase(u);
        dfs(v);
        return;
    }
}

int getp(int u) {
    return g[u].size() - (g[u].find(u) != g[u].end());
}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, n;
    cin >> m >> n;
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        if (b < a) swap(a, b);
        del[a][b] = 1;
    }

    int want = 0;
    for (int i = 0; i <= m; ++i) {
        for (int j = i; j <= m; ++j) {
            if (!del[i][j]) {
                ++want;
                g[i].insert(j);
                g[j].insert(i);
            }
        }
    }

    for (int i = 0; i <= m; ++i) {
        if (g[i].size() && getp(i) % 2) {
            ans.push_back({i});
            dfs(i);
        }
    }
    for (int i = 0; i <= m; ++i) {
        if (g[i].size()) {
            ans.push_back({i});
            dfs(i);
        }
    }

    cout << ans.size() << '\n';
    for (auto e : ans) {
        for (int x : e) cout << x << ' ';
        cout << "-1\n";
    }

    return 0;
}
