#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1100;

mt19937 rnd(228);

bool ch[MAXN];
bool del[MAXN][MAXN];

int ptr[MAXN];
vector <int> g[MAXN];
vector <vector <int> > ans;

bool used[MAXN * MAXN];
vector <pair <int, int> > ed;

void dfs(int u) {
    if (ch[u]) {
        ans.back().push_back(u);
        ch[u] = 0;
    }

    while (ptr[u] < g[u].size() && used[g[u][ptr[u]]]) ++ptr[u];

    if (ptr[u] == g[u].size()) {
        return;
    }
    else {
        int num = g[u][ptr[u]];
        used[num] = 1;
        ptr[u]++;
        int v = ed[num].first ^ ed[num].second ^ u;
        ans.back().push_back(v);
        dfs(v);
    }
}

int getp(int u) {
    return g[u].size() - ptr[u];
}

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, n;
    cin >> m >> n;
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        if (b < a) swap(a, b);
        del[a][b] = 1;
    }

    int want = 0;
    for (int i = 0; i <= m; ++i) {
        for (int j = i; j <= m; ++j) {
            if (!del[i][j]) {
                ++want;
                if (i == j) {
                    ch[i] = 1;
                }
                else {
                    g[i].push_back(ed.size());
                    g[j].push_back(ed.size());
                    ed.push_back({i, j});
                }
            }
        }
    }

    for (int i = 0; i <= m; ++i) {
        shuffle(g[i].begin(), g[i].end(), rnd);
    }

    vector <int> v;
    for (int i = 0; i <= m; ++i) v.push_back(i);
    shuffle(v.begin(), v.end(), rnd);

    for (int i : v) {
        if (g[i].size() && getp(i) % 2) {
            ans.push_back({i});
            dfs(i);
        }
    }
    shuffle(v.begin(), v.end(), rnd);
    for (int i : v) {
        if (ptr[i] < g[i].size() + ch[i]) {
            ans.push_back({i});
            dfs(i);
        }
    }

    cout << ans.size() << '\n';
    for (auto e : ans) {
        for (int x : e) cout << x << ' ';
        cout << "-1\n";
    }

    return 0;
}
