#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';

typedef long long ll;
const int N = 1e5 + 10;
std::vector<int> g[N];
int answ = 0;
int dp[N][2];

void dfs(int v, int p = -1) {
	dp[v][0] = dp[v][1] = 0;
	for (auto e : g[v]) {
		if (e != p) {
			dfs(e, v);
			dp[v][0] += std::max(dp[e][0], dp[e][1]);
		}
	}
	for (auto e : g[v]) {
		if (e != p) {
			int val = std::max(dp[e][0], dp[e][1]);
			dp[v][1] = std::max(dp[v][1], dp[v][0] - val + 1 + dp[e][0]);
		}
	}
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0); std::cout.tie(0);
	int t;
	std::cin >> t;
	FOR(test, t) {
		FOR(j, N) {
			g[j].clear();
		}
		answ = 0;
		int n;
		std::cin >> n;
		FOR(j, n - 1) {
			int a, b;
			std::cin >> a >> b;
			g[a].push_back(b);
			g[b].push_back(a);
		}
		dfs(0);
		std::cout << std::max(dp[0][1], dp[0][0]) << '\n';
	}

}	