#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T &a, T b) {
	if (b > a) {
		a = b;
	}
}

const int maxn = 10001;

int n;

vector<int> g[maxn];

int dp[maxn];

void dfs(int v, int par = -1) {
	int mx = 0;
	for (int to : g[v]) {
		if (to != par) {
			dfs(to, v);
			uax(mx, dp[to]);
		}
	}
	int cnt = 0;
	for (int to : g[v]) {
		if (to != par) {
			if (dp[to] == mx) {
				++cnt;
			}
		}
	}
	if (mx == 0) {
		dp[v] = 1;
		return;
	}
	if (mx == 1) {
		dp[v] = 2;
	} else {
		if (cnt > 2) {
			dp[v] = mx + 1;
		} else {
			dp[v] = mx;
		}
	}
}

void solve() {
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		++u;
		++v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(1);
	cout << dp[1] << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int T;
	cin >> T;
	for (int iter = 0; iter < T; ++iter) {
		solve();
	}
	return 0;
}