#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define pb push_back
#define all(x) (x).begin(), x.end()
#define size(s) (int)(s).size()

void bye() {
    cout << "\n";
    exit(0);
}

int sum(int r){
    return r * (r + 1) / 2;
}

bool used[1025][1025];
int nxt[1026][1026];
int p[1026][1026];
bool in_ans[1026][1026];
int comp[1026][1026];
bool del[1025][1025];

int m, n;
int clr = 1;

void dfs(int x, int y){
    comp[x][y] = comp[y][x] = clr;
    //cout << x << ' ' << y << endl;
    used[x][y]++;
    for(int xx = 0; xx <= m; xx++){
        if (!del[y][xx] && comp[y][xx] != comp[x][y] && p[y][xx] == -1){
            nxt[x][y] = xx;
            p[y][xx] = x;
            dfs(y, xx);
            return;
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    freopen("input.txt", "r", stdin);
    cin >> m >> n;
    map<pair<int, int>, bool> erased;
    for(int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        del[x][y] = del[y][x] = 1;
    }
    for(int i = 0; i <= m; i++)
        for(int j =0 ; j <= m; j++)
            p[i][j] = -1, nxt[i][j] = -1;

    for(int i = 0; i <= m; i++){
        for(int j = 0; j <= m; j++) {
            if (!used[i][j] && !del[i][j]){
                dfs(i, j);
              //  cout << endl;
                clr++;
            }
        }
    }
   // cout << "finish" << endl;
    vector<vector<pair<int, int>>> ans;
    for(int i = 0; i <= m; i++){
        for(int j = 0; j <= m; j++){
         //  cout << i << ' ' << j << " : nxt " << nxt[i][j] << "  p : " << p[i][j] << endl;
            if (!in_ans[i][j] && !del[i][j]){
                ans.pb({});
                int x = i, y = j;
                while(nxt[x][y]!=-1){
                    int tmpy=y;
                    y=nxt[x][y];
                    x=tmpy;
                }
                do {
                  //  cout << x << ' ' << y << endl;
                    if (in_ans[x][y]) break;
                    in_ans[y][x] = in_ans[x][y] = 1;
                    ans.back().pb({x, y});
                    int tmpx = x;
                    x = p[x][y];
                    y = tmpx;
                } while(x != -1);
            }
        }
    }
    cout << size(ans) << '\n';
    for(auto e : ans) {
        reverse(all(e));
        for(pair<int, int> v : e) {
            cout << v.first << ' ';
        }
        cout << e.back().second << ' ';
        cout << -1 << "\n";
    }
}
