#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define pb push_back
#define all(x) (x).begin(), x.end()
#define size(s) (int)(s).size()

void bye() {
    cout << "\n";
    exit(0);
}

bool in_ans[1026][1026];
int m, n;
vector<vector<pii>> ans;

void dfs(int x, int y, bool back = 0, bool str = 0) {
    in_ans[x][y] = in_ans[y][x] = 1;
    if (back) {
        for(int i = 0; i <= m; i++) {
            if (!in_ans[i][x]) {
                dfs(i, x, 1, 0);
                break;
            }
        }
    }
    ans.back().pb({y, x});
    if (str) {
        for(int i = 0; i <= m; i++) {
            if (!in_ans[y][i]) {
                dfs(y, i, 0, 1);
                break;
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    freopen("input.txt", "r", stdin);
    cin >> m >> n;

    for(int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        in_ans[x][y] = in_ans[y][x] = 1;
    }

    for(int i = 0; i <= m; i++) {
        for(int j = 0; j <= m; j++) {
            if (!in_ans[i][j]) {
                ans.pb({});
                dfs(i, j, 1, 1);
            }
        }
    }

    cout << size(ans) << '\n';
    for(auto e : ans) {
        reverse(all(e));
        for(pair<int, int> v : e) {
            cout << v.first << ' ';
        }
        cout << e.back().second << ' ';
        cout << -1 << "\n";
    }
}
