#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define pb push_back
#define all(x) (x).begin(), x.end()
#define size(s) (int)(s).size()

void bye() {
    cout << "\n";
    exit(0);
}

int sum(int r){
    return r * (r + 1) / 2;
}

vector<vector<int>> g;
vector<int> dp;
int n;

void dfs(int v, int p) {
    if (size(g[v]) == 1 && p != -1) {
        dp[v] = 1;
    } else {
        dp[v] = 2;
    }
    for(int to : g[v]) {
        if (to == p) continue;
        dfs(to, v);
        dp[v] = max(dp[v], dp[to]);
    }
    int cnt = 0;
    for(int to : g[v]) {
        if (to == p) continue;
        if (dp[to] == dp[v]) cnt++;
    }
    dp[v] += (cnt > 1);
}

void solve() {
    cin >> n;
    g.clear(), dp.clear();
    g.resize(n), dp.resize(n);
    for(int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
    }
    if (n == 1) {
        cout << 1;
        return;
    }
    for(int i = 0; i < n; i++) {
        if (size(g[i]) == 1) {
            dfs(i, -1);
            cout << dp[i];
            return;
        }
    }
}

int main() {
   // ios::sync_with_stdio(false);
   // cin.tie(NULL);
    freopen("input.txt", "r", stdin);
    int tt;
    cin >> tt;
    while(tt--){
        solve();
        cout << "\n";
    }
}
