#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<int> g[100009];
int par[100009];
int n;

void dfs_par(int v, int p) {
    par[v] = p;

    for (auto u : g[v]) {
        if (u != p) {
            dfs_par(u, v);
        }
    }
}

bool check(int k) {
    unordered_map<int, int> mm;

    for (int i = 0; i < n; i ++) {
        mm[i] = 1;
    }

    int c = 0;

    while (c <= 7 * n) {
        vector<pair<int, int> > a(n);
        for (auto p : mm) {
            //cout << '{' << p.first << ' ' << p.second << '}' << ' ';
            a[p.first] = {p.second * (g[p.first].size() + 1), p.first};
        }
        //cout << endl;

        sort(a.begin(), a.end());
        /*for (auto u : a) {
            cout << u.first << ' ' << u.second << endl;
        }
        cout << n - 1 - k << endl;*/

        for (int i = n - 1; i > n - 1 - k; i --) {
            //cout << a[i].first << endl;
            if (i == n - 1 && a[i].first == 0) return 1;
            mm[a[i].second] = 0;
        }

        for (int i = 0; i < n; i ++) {
            a[i] = {0, 0};
        }
        for (auto p : mm) {
            for (auto u : g[p.first]) {
                a[u].first += p.second;
            }

            a[p.first].first += p.second;
        }

        for (int i = 0; i < n; i ++) {
            mm[i] = a[i].first;
        }

        c++;
    }

    return 0;
}

void solve() {
    cin >> n;

    for (int i = 0; i <= n; i ++) {
        g[i].clear();
        par[i] = -1;

    }

    for (int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    dfs_par(0, -1);

    int l = -1, r = n;

    while (r - l > 1) {
        //cout <<"\t" << l << ' ' << r << endl;
        int m = (r + l) / 2;
        if (check(m)) {
            r = m;
        }

        else {
            l = m;
        }
    }

    cout << r << "\n";

    return;
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
