#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include "namuhs.h"
using namespace std;
using ll = long long;
using ld = long double;

const int N = 1E5 + 10;

mt19937 randint;

void find_max(int n, int & left, int & right)
{
    left = 1;
    right = n;
    for (int i = 1; i <= n; ++i)
    {
        if (compare_segments(i, i, left, right))
        {
            left = i;
            right = i;
        }
    }

    int delta = (n + 9999) / 10000;

    for (int i = 1; i <= n; i += delta)
    {
        for (int j = i; j <= n; j += delta)
        {
            if (compare_segments(i, j, left, right))
            {
                left = i;
                right = j;
            }
        }
    }

    int i = left, j = right;
    while (clock() < 0.25 * CLOCKS_PER_SEC)
    {
        for (int k = 0; k < 4; ++k)
        {
            i = min(max(i + rand() % 10 - 5, 1), n);
            j = min(max(j + rand() % 10 - 5, 1), n);
            if (i > j) continue;
            if (compare_segments(i, j, left, right))
            {
                left = i;
                right = j;
            }
        }
    }
}

