#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define long ll
#define double ld

/// Allocator?
/// Asserts?

const int M = 1025, N = M * M;

char bad[M][M];
int m, n_bad;

vector<pair<int, int>> answer;

int check()
{
    int n = (int)answer.size();
    int cnt = 1;
    for (int i = 0; i < n - 1; ++i)
    {
        if (answer[i + 1].second == answer[i].second)
        {
            swap(answer[i + 1].first, answer[i + 1].second);
        }
        if (answer[i].second != answer[i + 1].first)
        {
            ++cnt;
        }
    }
    return cnt;
}

int main()
{
#ifdef LOCAL_PC
    freopen("input.txt", "r", stdin);
#endif // LOCAL_PC
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> m >> n_bad;

    for (int a, b, i = 0; i < n_bad; ++i)
    {
        cin >> a >> b;
        bad[a][b] = 1;
        bad[b][a] = 1;
    }

    for (int a = 0; a <= m; ++a)
    {
        for (int b = a; b <= m; ++b)
        {
            if (bad[a][b] == 0)
            {
                answer.emplace_back(a, b);
            }

        }
    }

    vector<pair<int, int>> best_ans;
    int best = 1E9;

    while (clock() < 0.39 * CLOCKS_PER_SEC) for (int k = 0; k < 10; ++k)
    {
        int cur = check();
        if (cur < best)
        {
            best_ans = answer;
            best = cur;
        }
        random_shuffle(answer.begin(), answer.end());
    }

    cout << best << '\n';

    int n = best_ans.size();

    cout << best_ans[0].first << ' ' << best_ans[0].second << ' ';

    for (int i = 1; i < n; ++i)
    {
        if (best_ans[i - 1].second == best_ans[i].first)
        {
            cout << best_ans[i].second << ' ';
        }
        else
        {
            cout << "-1\n";
            cout << best_ans[i].first << ' ' << best_ans[i].second << ' ';
            --best;
        }
    }
    cout << "-1\n";
    assert(best == 1);
    return 0;
}

