#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include "namuhs.h"
using namespace std;
using ll = long long;
using ld = long double;

const int N = 1E5 + 10;

mt19937 randint;

using Interval = pair<int, int>;

Interval max(Interval a, Interval b)
{
    return compare_segments(a.first, a.second - 1, b.first, b.second - 1) ? a : b;
}

struct Answer
{
    Interval ans;
    Interval pref;
    Interval suff;
    Answer(int pos)
    {
        ans = { pos, pos + 1 };
        pref = { pos, pos + 1 };
        suff = { pos, pos + 1 };
    }
    Answer() : Answer((int)-1E9) {}
};

Answer operator+(const Answer & l, const Answer & r)
{
    Answer s;
    s.ans = max(l.ans, r.ans);
    Interval mid(l.suff.first, r.pref.second);
    s.ans = max(s.ans, mid);
    Interval bigpref(l.pref.first, r.pref.second);
    s.pref = max(l.pref, bigpref);
    Interval bigsuff(l.suff.first, r.suff.second);
    s.suff = max(r.suff, bigsuff);
    return s;
}

Answer get_sum(int l, int r)
{
    if (r - l == 1)
    {
        return Answer(l);
    }
    int m = (l + r) / 2;
    Answer lef = get_sum(l, m);
    Answer rig = get_sum(m, r);
    return lef + rig;
}

void find_max(int n, int & left, int & right)
{
    Answer s = get_sum(1, n + 1);
    left = s.ans.first;
    right = s.ans.second - 1;
}

