#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

int main() {
    int m, n;
    cin >> m >> n;
    vector<vector<int>> g(m + 2, vector<int> (m + 2, 1));
    vector<int> cnt(m + 2, m + 2);
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --cnt[a];
        --cnt[b];
        g[a][b] = 0;
        g[b][a] = 0;
    }

    int k = (m + 1) * (m + 1) - n;
    vector<vector<pii>> ans;
    while (k > 0) {
        int q = 1;
        for (int i = 0; i < (m + 1); ++i) {
            if (cnt[i] % 2 == 1) {
                ans.pb({});
                int idx = ans.size() - 1;
                int curr = i;
                while (1) {
                    int r = 0;
                    for (int j = 0; j < m + 1; ++j) {
                        if (g[curr][j]) {
                            --cnt[j];
                            --cnt[curr];
                            g[curr][j] = 0;
                            g[j][curr] = 0;
                            ans[idx].pb({i, j});
                            curr = j;
                            r = 1;
                            break;
                        }
                    }
                    if (!r) {
                        break;
                    }
                }
                q = 0;
                break;
            }
        }
            if (q) {
                for (int i = 0; i < (m + 1); ++i) {
                    if (cnt[i] == 0) {
                        continue;
                    }
                    ans.pb({});
                    int idx = ans.size() - 1;
                    int curr = i;
                    while (1) {
                        int r = 0;
                        for (int j = 0; j < m + 1; ++j) {
                            if (g[curr][j]) {
                                --cnt[j];
                                --cnt[curr];
                                g[curr][j] = 0;
                                g[j][curr] = 0;
                                ans[idx].pb({i, j});
                                curr = j;
                                r = 1;
                                break;
                            }
                        }
                        if (!r) {
                            break;
                        }
                    }
                    break;
                }
                break;
            }
        }
        cout << ans.size() << endl;
        for (int i = 0; i < ans.size(); ++i) {
            cout << ans[i][0].first << " ";
            for (int j = 0; j < ans[i].size(); ++j) {
                cout << ans[i][j].second << " ";
            }
            cout << endl;
        }
        return 0;
    }


