#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define pb emplace_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second
#define INF 1e9
#define EPS 1e-4
#define MAXN int(1e6)
#define maxmin(x, y) mp(max(x, y), min(x, y))
#define elif else if
#define prev gorgorod

inline void Routine() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

template<class U, class T>
istream &operator >> (istream &in, pair<U, T> &p) {
    in >> p.fi >> p.se;
    return in;
}


template<class U, class T>
ostream &operator << (ostream &out, const pair<U, T> &p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template<class T>
istream &operator >> (istream &in, vector<T> &v) {
    for (auto &i : v) {
        in >> i;
    }
    return in;
}

template<class T>
ostream &operator << (ostream &out, const vector<T> &v) {
    for (auto &i : v) {
        out << i << ' ';
    }
    return out;
}


vector<vector<int> > g;
vector<int> h, prev, w;
vector<bool> used;

void dfs(int v = 0) {
    for (auto &u : g[v]) {
        if (not used[u]) {
            used[u] = true;
            prev[u] = v;
            w[u] = w[v] + 1;
            dfs(u);
        }
    }
    if (v) {
        h[prev[v]] = max(h[prev[v]], h[v] + 1);
    }
}

signed main() {
    Routine();
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        g.resize(n);
        used.resize(n);
        h.resize(n);
        prev.resize(n);
        w.resize(n);
        for (int i = 1; i < n; i++) {
            int a, b;
            cin >> a >> b;
            g[a].pb(b);
            g[b].pb(a);
        }
        used[0] = true;
        vector<bool> was;
        dfs();
        int x = max_element(all(w)) - w.begin();
        int l = 0, r = n;
        while (r - l > 1) {
            was.assign(n, false);
            int m = r + l >> 1, temp = x;
            for (int i = 0; i < m; i++) {
                temp = prev[temp];
                was[temp] = true;
            }
            while (1) {
                int s = 0;
                for (auto &u : g[temp]) {
                    if (not was[u] && h[u] >= m) {
                        s++;
                    }
                }
                if (s > 1) {
                    l = m;
                    goto mark;
                }
                if (temp == 0) {
                    break;
                }
                for (int i = 0; i < m; i++) {
                    temp = prev[temp];
                    was[temp] = true;
                }
            }
            r = m;
            mark:;
        }
        cout << r + 1 << '\n';
        g.clear();
        used.clear();
        w.clear();
        h.clear();
    }
    return 0;
}

