#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
typedef long long ll;
typedef pair < int, int > pii;
typedef pair < ll, ll > pll;
typedef double db;
typedef long double ldb;

#ifdef MY
    const int N = 1e2;
#else
    const int N = 1e5 + 5;
#endif // MY

int n;
vector < int > gr[N];
int lev, ver;
int res = 0;

void dfs(int v, int l = 1, int pr = -1) {
    if (l > lev)
        lev = l, ver = v;
    for (int u : gr[v])
        if (u != pr)
            dfs(u, l + 1, v);
}

int ddfs(int v, int pr = -1) {
    int a = 0, b = 0;
    for (auto u : gr[v]) {
        if (u == pr)
            continue;
        int c = ddfs(u, v);
        if (c == b)
            a = c;
        else if (c > b)
            a = b, b = c;
        else if (c > a)
            a = c;
    }
    res = max(a + 1, res);
    return b + 1;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
//        if (n == 1) {
//            cout << "1\n";
//            continue;
//        }
        for (int i = 0; i < n; i++)
            gr[i].clear();
        for (int i = 1; i < n; i++) {
            int v, u;
            cin >> v >> u;
            //v--, u--;
            gr[v].pb(u);
            gr[u].pb(v);
        }
        lev = 0, ver = -1;
        dfs(0);
        lev = 0;
        res = 0;
        ddfs(ver);
        cout << res << endl;
    }
    return 0;
}
