#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

#define int long long

int t;
vector < vector < int > > a(100001);
vector < int > p(100001);
vector < int > d(100001);

void dfs1(int v, int dist) {
    d[v] = dist;
    for (int i = 0; i < a[v].size(); i++) {
        if (d[a[v][i]] == -1)
            dfs1(a[v][i], dist + 1);
    }
}

void dfs2(int v, int dist, int pr) {
    d[v] = dist;
    p[v] = pr;
    for (int i = 0; i < a[v].size(); i++) {
        if (d[a[v][i]] == -1)
            dfs2(a[v][i], dist + 1, v);
    }
}

int dfs3(int v, int dist) {
    d[v] = dist;
    int x = dist;
    for (int i = 0; i < a[v].size(); i++) {
        if (d[a[v][i]] == -1)
            x = max(x, dfs3(a[v][i], dist + 1));
    }
    return x;
}

void cc() {
    for (int j = 0; j < 100001; j++) {
        a[j].clear();
        d[j] = -1;
        p[j] = -1;
    }
}

void solve() {
    cin >> t;
    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        cc();
        for (int j = 0; j < n - 1; j++) {
            int f, s;
            cin >> f >> s;
            a[f].push_back(s);
            a[s].push_back(f);
        }
        dfs1(0, 1);
        int x = 0, gi = 0;
        for (int j = 0; j < n; j++) {
            if (x < d[j]) {
                x = d[j];
                gi = j;
            }
        }
        for (int j = 0; j < 100001; j++) {
            p[j] = -1;
            d[j] = -1;
        }
        dfs2(gi, 1, -1);
        int u = 0, o = 0;
        for (int j = 0; j < n; j++) {
            if (u < d[j]) {
                u = d[j];
                o = j;
            }
        }
        int ans = 0;
        for (int j = 0; j < 100001; j++) {
            d[j] = -1;
        }
        int y = o;
        while (y != -1) {
            d[y] = 0;
            y = p[y];
        }
        while (o != -1) {
            ans = max(ans, dfs3(o, 1));
            o = p[o];
        }
        cout << ans << endl;
    }

}