#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ll long long
#define ld long double

#define vi vector<int>

#define all(a) a.begin(), a.end()
#define pb push_back

using namespace std;

void dfs(int v, vi &dp, vector<bool> &was, vector<vi> &g, int f) {
    was[v] = true;

    int rep = 1;
    int c = -1;

    for(auto w : g[v]) {
        if(!was[w]) {
            dfs(w, dp, was, g, f);

            if(c < dp[w]) {
                c = dp[w];
                rep = 1;
            } else if(c == dp[w]) {
                rep++;
            }
        }
    }

    if(c == -1) {
        dp[v] = 1;
    } else if(c == 1) {
        dp[v] = 2;
    } else {
        if(rep == 1) dp[v] = c;
        else if(rep == 2 && v == f) dp[v] = c;
        else dp[v] = c+1;
    }
}

void dfs2(int v, vector<bool> &was, vector<vi> &g, vi &dist) {
    was[v] = true;

    int x = -1;
    for(auto w : g[v]) {
        if(!was[w]) {
            dfs2(w, was, g, dist);

            if(x < dist[w]) {
                x = dist[w];
            }
        }
    }

    if(g[v].size() == 0) dist[v] = 1;
    else dist[v] = x;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while(t > 0) {
        --t;

        int n;
        cin >> n;

        vector<vi> g(n);
        for(int i = 0; i < n-1; ++i) {
            int v, w;
            cin >> v >> w;

            g[v].pb(w);
            g[w].pb(v);
        }

        /*for(int j = 0; j < n; ++j) {
            vi dp(n, 1999999999);
            vector<bool> was(n, false);

            dfs(j, dp, was, g, j);
            answ = min(answ, dp[j]);
        }*/

        vector<bool> was1(n, false);
        vi dist1(n, 1999999999);

        dfs2(0, was1, g, dist1);

        int mx = 0;
        for(int i = 1; i < n; ++i) {
            if(dist1[i] > dist1[mx]) mx = i;
        }

        vector<bool> was2(n, false);
        vi dist2(n, 1999999999);

        dfs2(mx, was2, g, dist2);

        int v0 = 0;

        for(int i = 1; i < n; ++i) {
            if(max(dist1[i], dist2[i]) < max(dist1[v0], dist2[v0])) {
                v0 = i;
            }
        }

        vector<bool> was(n, false);
        vi dp(n, 1999999999);

        dfs(v0, dp, was, g, v0);

        cout << dp[v0] << "\n";
    }
}
