#include "namuhs.h"
#include <bits/stdc++.h>
using namespace std;

bool negativan[100005];

int niz[100005];
int pre[100005];

struct par{
    int l;
    int r;
};

par maxlevo[1000000];
par maxdesno[1000000];
par maxukup[1000000];

/*bool compare_segments(int a, int b, int c, int d){
    cout << "Alo " << a << " " << b << " " << c << " " << d << endl;
    return pre[b]-pre[a-1] >= pre[d]-pre[c-1];
}*/

bool uporedi(int l1, int r1, int l2, int r2){
    if(l1 == 0 || r1 == 0) return 0;
    if(l2 == 0 || r2 == 0) return 1;
    return compare_segments(l1, r1, l2, r2);
}

void resi(int node, int l, int r){
    if(l == r){
        if(negativan[l]){
            maxlevo[node].l = l;
            maxlevo[node].r = r;
            maxdesno[node].l = l;
            maxdesno[node].r = r;
            maxukup[node].l = l;
            maxukup[node].r = r;
        }
        else{
            maxlevo[node].l = l;
            maxlevo[node].r = r;
            maxdesno[node].l = l;
            maxdesno[node].r = r;
            maxukup[node].l = l;
            maxukup[node].r = r;
        }
        return;
    }
    int mid = (l+r)/2;
    resi(node*2, l, mid);
    resi(node*2+1, mid+1, r);
    ///maxlevo
    //cout << "Dibag " << l << " " << r << " ";
    if(uporedi(maxlevo[node*2].l, maxlevo[node*2+1].r, maxlevo[node*2].l, maxlevo[node*2].r)){
        maxlevo[node].l = maxlevo[node*2].l;
        maxlevo[node].r = maxlevo[node*2+1].r;
    }
    else{
        maxlevo[node].l = maxlevo[node*2].l;
        maxlevo[node].r = maxlevo[node*2].r;
    }
    ///maxdesno
    if(uporedi(maxdesno[node*2].l, maxdesno[node*2+1].r, maxdesno[node*2+1].l, maxdesno[node*2+1].r)){
        maxdesno[node].l = maxdesno[node*2].l;
        maxdesno[node].r = maxdesno[node*2+1].r;
    }
    else{
        maxdesno[node].l = maxdesno[node*2+1].l;
        maxdesno[node].r = maxdesno[node*2+1].r;
    }
    ///maxukup
    maxukup[node].l = l;
    maxukup[node].r = r;
    if(!uporedi(maxukup[node].l, maxukup[node].r, maxlevo[node].l, maxlevo[node].r)){
        maxukup[node].l = maxlevo[node].l;
        maxukup[node].r = maxlevo[node].r;
    }
    if(!uporedi(maxukup[node].l, maxukup[node].r, maxdesno[node].l, maxdesno[node].r)){
        maxukup[node].l = maxdesno[node].l;
        maxukup[node].r = maxdesno[node].r;
    }
    if(!uporedi(maxukup[node].l, maxukup[node].r, maxukup[node*2].l, maxukup[node*2].r)){
        maxukup[node].l = maxukup[node*2].l;
        maxukup[node].r = maxukup[node*2].r;
    }
    if(!uporedi(maxukup[node].l, maxukup[node].r, maxukup[node*2+1].l, maxukup[node*2+1].r)){
        maxukup[node].l = maxukup[node*2+1].l;
        maxukup[node].r = maxukup[node*2+1].r;
    }
    ///cout << "Dibag " << l << " " << r << " " << maxukup[node].l << " " << maxukup[node].r << " " << endl;
}

void find_max(int N, int& left, int& right){
    left = 1;
    right = 1;
    for(int i=2; i<=N; i++){
        if(!compare_segments(i-1, i, i, i)){
            negativan[i-1] = 1;
        }
    }
    if(!compare_segments(N-1, N, N-1, N-1)){
        negativan[N] = 1;
    }
    resi(1, 1, N);
    left = maxukup[1].l;
    right = maxukup[1].r;
    //cout << left << " " << right << endl;
}
/*
int main(){

    int n;
    cin >> n;
    for(int i=1; i<=n; i++){
        cin >> niz[i];
        pre[i] = pre[i-1]+niz[i];
    }
    int l, r;
    find_max(n, l, r);
}
*/
