#include <bits/stdc++.h>
using namespace std;

bool visited[100005];
int dp[100005];
vector <int> graf[100005];

void dfs(int v){
    visited[v] = 1;
    bool leaf = 1;
    vector <int> vec;
    for(auto c : graf[v]){
        if(!visited[c]){
            leaf = 0;
            dfs(c);
            if(dp[c] > 1) vec.push_back(dp[c]);
        }
    }
    if(leaf){
        dp[v] = 1;
        return;
    }
    dp[v] = 2;
    sort(vec.begin(), vec.end());
    int x = vec.size();
    if(vec.size() == 0){
        dp[v] = 2;
    }
    else if(vec.size() == 1){
        dp[v] = max(dp[v], vec[0]);
    }
    else if(vec.size() == 2){
        dp[v] = max(dp[v], vec[1]);
    }
    else if(vec[x-1] > vec[x-2]){
        dp[v] = max(dp[v], vec[x-1]);
    }
    else{
        dp[v] = max(dp[v], vec[x-2]+1);
    }
}

void solve(){
    int n;
    cin >> n;
    for(int i=1; i<=n; i++){
        graf[i].clear();
        visited[i] = 0;
    }
    for(int i=1; i<n; i++){
        int a, b;
        cin >> a >> b;
        a++;
        b++;
        graf[a].push_back(b);
        graf[b].push_back(a);
    }
    if(n == 1){cout << "1\n"; return;}
    int res = n;
    for(int i=1; i<=n; i++){
        for(int j=1; j<=n; j++){
            visited[j] = 0;
            dp[j] = 0;
        }
        dfs(i);
       // cout << res << " " << min(dp[i][0], dp[i][1]) << endl;
        res = min(res, dp[i]);
    }
    cout << res << "\n";
}

int main(){

    int t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}

/*
2
8
0 1
0 2
0 3
1 4
2 5
3 6
3 7
9
0 1
0 2
0 3
1 4
1 5
1 6
3 7
3 8
*/
