#include <bits/stdc++.h>
#define pb push_back
#define maxn 100005
using namespace std;
int t;
vector<int> graf[maxn];
bool bio[maxn];
int mindep;
int podstabla[maxn];
int dfs(int x)
{
    bio[x] = 1;
    podstabla[x] = 1;
    for(auto c:graf[x])
    {
        if(!bio[c])
            podstabla[x] += dfs(c);
    }
    return podstabla[x];
}
bool probaj(int y, int x)
{
    int kolko = 0;
    for(auto c:graf[x])
    {
        if(podstabla[c] + 1> y)
        {
            kolko++;
            if(kolko >= 3)
                return false;
        }
    }
    return true;
}
bool moze(int y, int n)
{
    for(int i=1; i<=n; i++)
    {
        if(!probaj(y,i))
            return 0;
    }
    return 1;
}

void solve()
{
    int n;
    cin >> n;
    for(int i=1; i<=n; i++)
    {
        graf[i].clear();
        bio[i] = 0;
    }
    for(int i=1; i<=n-1; i++)
    {
        int a,b;
        cin >> a >> b;
        graf[a+1].pb(b+1);
        graf[b+1].pb(a+1);
    }
    if(n == 1)
    {
        cout << 1 << endl;
        return;
    }
    dfs(1);

    int l = 1;
    int r = n;
    while(l < r)
    {
        int mid = (l+r)/2;
        if(moze(mid,n))
            r = mid;
        else
            l = mid+1;
    }
    cout << l << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin >> t;
    while(t--)
        solve();
    return 0;
}
