#include <bits/stdc++.h>
using namespace std;

#define pb push_back

int t;
int n;
vector<int> graph[100005];
bool visited[100005];
pair<int, int> x[100005][3];
int helped[100005];

int dfs(int node)
{
    visited[node] = true;
    x[node][0] = x[node][1] = x[node][2] = {-1, -1};
    if(graph[node].size() == 1){
        return 1;
    }

    for(auto c : graph[node]){
        if(!visited[c]){
            int help = dfs(c) + 1;
            if(help > x[node][0].first){
                x[node][2] = x[node][1];
                x[node][1] = x[node][0];
                x[node][0] = {help, c};
            }
            else if(help > x[node][1].first){
                x[node][2] = x[node][1];
                x[node][1] = {help, c};
            }
            else if(help > x[node][2].first){
                x[node][2] = {help, c};
            }
        }
    }

    return x[node][0].first;
}

int dfs1(int node)
{
    if(helped[node] != -1){
        return helped[node];
    }
    //cout << "node = " << node << "\n";
    if(node == -1){
        //cout << "RETURN\n";
        return 1;
    }

    int help = max(x[node][2].first, 1);
    //cout << "1. help = " << help << "\n";
    for(int i = 0; i < 3; ++i){
        help = max(help, max(dfs1(x[node][0].second), dfs1(x[node][1].second)));
    }
    //cout << "FINAL help for node " << node << " is " << help << "\n";
    helped[node] = help;
    return help;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> t;
    while(t--){
        cin >> n;

        for(int i = 0; i < n; ++i){
            graph[i].clear();
            visited[i] = false;
            helped[i] = -1;
        }

        for(int i = 0; i < n-1; ++i){
            int u, v;
            cin >> u >> v;

            graph[u].pb(v);
            graph[v].pb(u);
        }

        dfs(0);
        cout << dfs1(0) << "\n";
    }

    return 0;
}

/*
2
8
0 1
0 2
0 3
1 4
2 5
3 6
3 7
9
0 1
0 2
0 3
1 4
1 5
1 6
3 7
3 8
*/

