#include<iostream>
#include<vector>
using namespace std;
bool removed[1024][1024];
struct edge
{
    int from, to;
};
vector<int> edges[1024];
int comp[1024];
int numberOfCoveredNodes = 0;
bool visited[1025];
int n,m;
void GenerateEdges(int m)
{
    for(int i = 0; i <= m; ++i)
    {
        for(int j = i; j <= m; ++j)
        {
            if(removed[i][j]) continue;
            else
            {
                edge temp;
                edges[i].push_back(j);
                if(i != j) edges[j].push_back(i);
            }

        }
    }
}

void Input(int n)
{
    for(int i = 0; i < n; ++i)
    {
        /*int temp, temp1;
        cin>>temp>>temp1;
        matrix[temp][temp1] = false;
        matrix[temp1][temp] = false;*/
        int temp, temp1;
        cin>>temp>>temp1;
        removed[temp][temp1] = true;
    }
}

void SetComponents(int currentNode, int currentComp)
{
    if(comp[currentNode] == 0)
    {
        comp[currentNode] = currentComp;
        numberOfCoveredNodes++;
    }
    for(int i = 0; i < edges[currentNode].size(); ++i)
    {
        if(edges[currentNode][i] == currentNode) continue;
        if(comp[edges[currentNode][i]] != 0) continue;
        SetComponents(edges[currentNode][i], currentComp);
    }
}

bool looped = false;
void Comps(int currentNode)
{
    cout<<currentNode<<" ";
    if(!visited[currentNode]) visited[currentNode] = true;

    for(int i = 0; i < edges[currentNode].size(); ++i)
    {
        if(edges[currentNode][i] == currentNode)
        {
            if(!looped)
            {
                looped = true;

                Comps(edges[currentNode][i]);
            }
        }
        else
        {
            looped = false;

            if(!visited[edges[currentNode][i]])Comps(edges[currentNode][i]);
        }
    }
}
int FindFirst(int current)
{
    if(!visited[current]) visited[current] = true;
    for(int i = 0; i < edges[current].size(); ++i)
    {
        if(edges[current][i] == current)
        {
            if(i == edges[current].size()) break;
            i++;
        }

        else if(visited[edges[current][i]])
        {
            if(i == edges[current].size()) break;
            i++;
        }

        else
        {
            return FindFirst(edges[current][i]);
        }
    }
    return current;
}

int main()
{
    cin>>m>>n;
    Input(n);
    GenerateEdges(m);
    int currentComp = 1;




    while(numberOfCoveredNodes < m )
    {

        for(int i = 0; i < m; ++i)
        {
            if(comp[i] == 0)
            {
                SetComponents(i, currentComp);
                break;
            }
        }
        currentComp++;
    }
    cout<<currentComp - 1<<endl;

    for(int i = 1; i <= currentComp; ++i)
    {
        for(int j = 0; j <= m; ++j)
        {
            if(comp[j] == i)
            {
                int first = FindFirst(j);
                for(int k = 0; k <= m; ++k) visited[k] = false;
                Comps(first);
                cout<<-1<<endl;
                break;
            }
        }
    }
    return 0;
}





/*3 5
0 2
1 1
1 2
1 3
3 3*/
/*3 6
0 2
1 1
1 2
1 3
3 3
0 3*/
/*
for(int i = 0; i <= m; ++i)
    {
        cout<<i<<" ";
        for(int j = 0; j < edges[i].size(); ++j)
        {
            cout<<edges[i][j]<<" ";
        }
        cout<<endl;
    }
    */
