#include<iostream>
#include<cstdio>
#include<vector>
#include<queue>
#include<algorithm>

using namespace std;

vector<vector<int> > v;
int dad[100000];
int depth[100000];
int ans[100000];
int layers[100000];
int tests;
int n;
queue<int> q;

int main ()
{
    scanf("%d", &tests);

    for (int iii=0; iii<tests; iii++)
    {
        scanf("%d", &n);
        v.resize(0);
        v.resize(n);
        for (int i=0;i<n-1;i++)
        {
            int a,b;
            scanf("%d%d", &a, &b);
            dad[b] = a;
            v[a].push_back(b);
        }
        for (int i=0; i<n; i++)
        {
            if (v[i].size() == 0)
            {
                q.push(i);
            }
            depth[i] = 0;
        }
        int counter = 0;
        while (!q.empty())
        {
            int cur = q.front();
            q.pop();
            if (cur == 0) continue;

            if (depth[dad[cur]] == 0) q.push(dad[cur]);
            depth[dad[cur]] = max(depth[dad[cur]], depth[cur]+1);
            counter++;
        }
        int last, layer;
        vector<int> ordered;
        q.push(0);
        while (!q.empty())
        {
            int cur = q.front();
            ordered.push_back(cur);
            layers[cur] = layer;
            for (int i=0; i<v[cur].size(); i++)
            {
                q.push(v[cur][i]);
            }

            if (last == cur && v[cur].size() > 0)
            {
                last = v[cur][v[cur].size()-1];
                layer++;
            }
            q.pop();
        }
        for (int i=ordered.size()-1; i>=0; i--)
        {
            int curindex = ordered[i];
            cout<<curindex<<endl;
            if (depth[curindex] == 0) ans[curindex] = 1;
            else
            {
                if (v[curindex].size() == 1) ans[curindex] = 2;
            }
        }

        for (int i=0; i<n; i++) cout<<i<<": "<<ans[i]<<endl;

        //for (int i=0; i<n; i++) cout<<i<<": "<<depth[i]<<endl;

//        for (int i=1; i<n; i++) ans = max(ans, depth[i]+1);
//
//        int sz = v[0].size();
//        if (sz > 2)
//        {
//
//            int fin[sz];
//            for (int i=0; i<sz; i++) fin[i] = depth[v[0][i]];
//            sort(fin, fin+sz);
//
//            ans = max(ans, fin[sz-3]+2);
//        }
    }

}

/**

2
8
0 1
0 2
0 3
1 4
2 5
3 6
3 7

9
0 1
0 2
0 3
1 4
1 5
1 6
3 7
3 8

*/
