#include<iostream>
#include<cstdio>
#include<map>
#include<vector>

using namespace std;

int m,n,am,ans;
int amount[1024];
map<pair<int , int>, bool > excluded;
vector<int> singles;

void goNext(int * a, int * b)
{
    *b = *b + 1;
    if (*b > m)
    {
        *a = *a + 1;
        *b = *a;
    }
}

int main ()
{
    cin>>m>>n;
    for (int i=0;i<=m;i++)
        for (int j=i;j<=m;j++)
            excluded[make_pair(i,j)] = false;
    for (int i=0;i<n;i++)
    {
        amount[i]+=m;
        int a,b;
        scanf("%d%d",&a,&b);
        if (a > b) swap(a, b);
        if (a != b)
        {
            amount[a]--;
            amount[b]--;
        }
        excluded[make_pair(a, b)] = true;
    }
    for (int i=0;i<=m;i++)
    {
        if (amount[i]%2==1) am++;
        if (amount[i] == 0 && excluded[make_pair(i, i)])
        {
            am++;
            singles.push_back(i);
        }
    }
    ans = min(1, am/2);
    cout<<ans<<endl;

    int nextA = 0, nextB = 0;
    vector<pair<int, int> > before, after;
    pair<int, int> mid;
    bool br = false;
    for (int i=0; i<singles.size(); i++) cout<<singles[i]<<" "<<singles[i]<<" -1"<<endl;
    for (int i=0; i<ans - singles.size(); i++)
    {
        before.resize(0);
        after.resize(0);
        while (excluded[make_pair(nextA, nextB)])
        {
            goNext(&nextA, &nextB);
        }

        before.emplace_back(nextA, nextB);
        after.emplace_back(nextA, nextB);

        excluded[make_pair(nextA, nextB)] = true;
        while (1)
        {
            while (excluded[make_pair(nextA, nextB)] || !(after.back().second == nextA || after.back().second == nextB))
            {
                goNext(&nextA, &nextB);
                if (nextA > m)
                {
                    br = true;
                    break;
                }
            }
            if (br == true) break;
            excluded[make_pair(nextA, nextB)] = true;
            if (after.back().second == nextB) swap(nextA, nextB);
            after.emplace_back(nextA, nextB);
            nextA = after[0].first;
            nextB = after[0].second;
        }

        nextA = after[0].first;
        nextB = after[0].second;

        br = false;

        while (1)
        {
            while (excluded[make_pair(nextA, nextB)] || !(before.back().first == nextA || before.back().first == nextB))
            {
                goNext(&nextA, &nextB);
                if (nextA > m)
                {
                    br = true;
                    break;
                }
            }
            if (br == true) break;
            excluded[make_pair(nextA, nextB)] = true;
            if (before.back().second == nextA) swap(nextA, nextB);
            before.emplace_back(nextA, nextB);
            nextA = before[0].first;
            nextB = before[0].second;
        }

        for (int j=before.size()-1; j>=0; j--) cout<<before[j].first<<" ";
        for (int j=1; j<after.size(); j++) cout<<after[j].first<<" ";
        cout<<after[after.size()-1].second<<" -1"<<endl;
    }

}

/**
3 5
0 2
1 1
1 2
1 3
3 3
*/
