#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 100000;

int n;
vector < int > ln [MAXN];
//int mem [MAXN][MAXN];

int longest_path_to_leaf (int s, int prev = -1)
{
    //if (mem [s][prev] != 0) return mem [s][prev]
    int ans = 1;
    for (auto& x : ln [s])
    {
        if (x != prev)
            ans = max (ans, longest_path_to_leaf (x, s) + 1);
    }
    return /*mem [s][prev] = */ans;
}

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);
    int t;
    cin >> t;
    while (t -- > 0)
    {
        cin >> n;
        for (int i = 0 ; i < n - 1 ; i ++)
        {
            int a, b;
            cin >> a >> b;
            ln [a].push_back (b);
            ln [b].push_back (a);
        }
        int ans = MAXN;
        for (int i = 0 ; i < n ; i ++)
            ans = min (ans, longest_path_to_leaf (i));
        cout << ans << endl;
        for (int i = 0 ; i < n ; i ++)
            ln [i].clear ();
    }
}
